
local timeTot = 0
local timeLog = 0
local timePerLog = 60+math.random() / World.TimeWarpFactor

local Get = Object.GetProperty
local Set = Object.SetProperty
local Find = Object.GetNearbyObjects

local LightPos = { [1] = -0.005, [2] = -0.0025, [3] = 0.0025, [4] = 0.005 }
local MyStuff = { "FireplaceFire","SmokeGenerator","LightRed","WallLight","Light","FireplaceLog" }

function Create()
	DetectGameVersion()
	Set(this,"Light",true)
	LightOn = true
	Interface.AddComponent(this,"toggleDelete", "Button", "tooltip_toggleRemoveFireplace")
	Interface.AddComponent(this,"toggleLight", "Button", "tooltip_toggleStoveLightOn")
	if RedLightPossible == true then
		Interface.AddComponent(this,"toggleLightColour", "Button", "tooltip_toggleStoveLightWhite")
	end
	timePerUpdate = 1
	MyLogLeft = Object.Spawn("Log",this.Pos.x-0.75,this.Pos.y+1.25)
	MyLogLeft.Or.x = -1
	Set(MyLogLeft,"StoveID",this.Id.u)
end

function DetectGameVersion()
	MyRedLight = Object.Spawn("LightRed",0,0)
	if Exists(MyRedLight) then 
		RedLightPossible = true
		MyRedLight.Delete()
	end
	-- MyWallLight = Object.Spawn("WallLight",0,0)
	MyWallLight = Object.Spawn("FloodLight",0,0)
	if Exists(MyWallLight) then
		MyWallLight.Delete()
	else
		Is2018Edition = true
	end
end

function Update(timePassed)
	if timePerUpdate == nil then
		DetectGameVersion()
		Interface.AddComponent(this,"toggleDelete", "Button", "tooltip_toggleRemoveFireplace")
		if not this.Light then
			Interface.AddComponent(this,"toggleLight", "Button", "tooltip_toggleStoveLightOff")
		else
			LightOn = true
			Interface.AddComponent(this,"toggleLight", "Button", "tooltip_toggleStoveLightOn")
			if RedLightPossible == true then
				Interface.AddComponent(this,"toggleLightColour", "Button", "tooltip_toggleStoveLightColour")
			end
		end
		for thatSmoke in next, Find(this,"SmokeGenerator",2) do
			MySmoke = thatSmoke
			break
		end
		for thatFire in next, Find(this,"FireplaceFire",1) do
			if thatFire.StoveID == this.Id.u and thatFire.Left == true then MyFireL = thatFire end
			if thatFire.StoveID == this.Id.u and thatFire.Right == true then MyFireR = thatFire end
		end
		for thatLog in next, Find(this,"FireplaceLog",1) do
			if thatLog.StoveID == this.Id.u then MyLog = thatLog end
			break
		end
		if not Is2018Edition then
			for thatLight in next, Find(this,"WallLight",1) do
				if thatLight.StoveID == this.Id.u then MyLight = thatLight end
				break
			end
			for thatLight in next, Find(this,"LightRed",1) do
				if thatLight.StoveID == this.Id.u then MyLight = thatLight end
				break
			end
		else
			for thatLight in next, Find(this,"Light",1) do
				if thatLight.StoveID == this.Id.u then MyLight = thatLight end
				break
			end
		end
		timePerUpdate = math.random(15,35) / 100
	end

	timeTot = timeTot + timePassed
	if timeTot >= timePerUpdate then
		timeTot = 0
		if this.SubType > 0 then
			if Exists(MyFireL) and Exists(MyFireR) then
				MyFireL.SubType = math.random(1,4)
				MyFireR.SubType = math.random(1,4)
				if LightOn and Exists(MyLight) then
					MyLight.Pos.x = this.Pos.x+0.0225 + LightPos[MyFireL.SubType]
				end
			else
				timeLog = timePerLog
			end
			if not Exists(MyLog) then
				timeLog = timePerLog
			end
			timePerUpdate = math.random(15,35) / 100
		end
		timeLog = timeLog + timePassed
		if not Exists(MySmoke) or timeLog >= timePerLog then
			if not SmokeRemoved then
				for j = 1,#MyStuff do
					for thatStuff in next, Find(this,MyStuff[j],2) do
						if thatStuff.StoveID == this.Id.u then thatStuff.Delete() end
					end
				end
				MyFireL,MyFireR,MyLight,MySmoke,MyLog = nil,nil,nil,nil
				SmokeRemoved = true
			end
			this.CreateJob("LogInFireplace")
			this.SubType = 0
		end
	end
end

function JobComplete_LogInFireplace()
	this.CancelJob("LogInFireplace")
	MySmoke = Object.Spawn("SmokeGenerator",this.Pos.x,this.Pos.y-1.25)
	MySmoke.StoveID = this.Id.u
	
	MyLog = Object.Spawn("FireplaceLog",this.Pos.x,this.Pos.y)
	MyLog.StoveID = this.Id.u
	this.Slot0.i = MyLog.Id.i
	this.Slot0.u = MyLog.Id.u
	MyLog.CarrierId.i = this.Id.i
	MyLog.CarrierId.u = this.Id.u
	MyLog.Loaded = true
	
	MyFireL = Object.Spawn("FireplaceFire",this.Pos.x,this.Pos.y+0.25)
	MyFireL.StoveID = this.Id.u
	MyFireL.Left = true
	this.Slot1.i = MyFireL.Id.i
	this.Slot1.u = MyFireL.Id.u
	MyFireL.CarrierId.i = this.Id.i
	MyFireL.CarrierId.u = this.Id.u
	MyFireL.Loaded = true
	
	MyFireR = Object.Spawn("FireplaceFire",this.Pos.x,this.Pos.y+0.25)
	MyFireR.StoveID = this.Id.u
	MyFireR.Right = true
	this.Slot2.i = MyFireR.Id.i
	this.Slot2.u = MyFireR.Id.u
	MyFireR.CarrierId.i = this.Id.i
	MyFireR.CarrierId.u = this.Id.u
	MyFireR.Loaded = true
	
	if LightOn then
		if not Is2018Edition then
			if this.RedLight == true then
				MyLight = Object.Spawn("LightRed",this.Pos.x,this.Pos.y+0.25)
			else
				MyLight = Object.Spawn("WallLight",this.Pos.x,this.Pos.y+0.05)
			end
		else
			MyLight = Object.Spawn("Light",this.Pos.x,this.Pos.y+0.4)
		end
		MyLight.StoveID = this.Id.u
	end
	this.SubType = 1
	this.Damage = 0
	timeLog = 0
	SmokeRemoved = nil
	timePerLog = 60+math.random(10,60) / World.TimeWarpFactor
end

function Exists(theObject)
	if theObject ~= nil and theObject.SubType ~= nil then
		return true
	else
		return false
	end
end

function toggleLightClicked()
	if this.Light == true then
		Set(this,"Light",nil)
		LightOn = nil
		if not Is2018Edition then
			for thatLight in next, Find(this,"WallLight",1) do
				if thatLight.StoveID == this.Id.u then thatLight.Delete() end
				break
			end
			for thatLight in next, Find(this,"LightRed",1) do
				if thatLight.StoveID == this.Id.u then thatLight.Delete() end
				break
			end
			Interface.RemoveComponent(this,"toggleLightColour")
		else
			for thatLight in next, Find(this,"Light",1) do
				if thatLight.StoveID == this.Id.u then thatLight.Delete() end
				break
			end
		end
		this.SetInterfaceCaption("toggleLight", "tooltip_toggleStoveLightOff")
	else
		LightOn = true
		Set(this,"Light",true)
		if this.SubType > 0 then
			if not Is2018Edition then
				if this.RedLight == true then
					MyLight = Object.Spawn("LightRed",this.Pos.x,this.Pos.y+0.25)
				else
					MyLight = Object.Spawn("WallLight",this.Pos.x,this.Pos.y+0.05)
				end
			else
				MyLight = Object.Spawn("Light",this.Pos.x,this.Pos.y+0.4)
			end
			MyLight.StoveID = this.Id.u
		end
		this.SetInterfaceCaption("toggleLight", "tooltip_toggleStoveLightOn")
		if not Is2018Edition then
			if this.RedLight == true then
				Interface.AddComponent(this,"toggleLightColour", "Button", "tooltip_toggleStoveLightRed")
			else
				Interface.AddComponent(this,"toggleLightColour", "Button", "tooltip_toggleStoveLightWhite")
			end
		end
	end
end

function toggleLightColourClicked()
	for thatLight in next, Find(this,"WallLight",1) do
		if thatLight.StoveID == this.Id.u then thatLight.Delete() end
		break
	end
	for thatLight in next, Find(this,"LightRed",1) do
		if thatLight.StoveID == this.Id.u then thatLight.Delete() end
		break
	end
	if this.RedLight == true then
		Set(this,"RedLight",nil)
		if this.SubType > 0 then
			MyLight = Object.Spawn("WallLight",this.Pos.x,this.Pos.y+0.05)
			MyLight.StoveID = this.Id.u
		end
		this.SetInterfaceCaption("toggleLightColour", "tooltip_toggleStoveLightWhite")
	else
		Set(this,"RedLight",true)
		if this.SubType > 0 then
			MyLight = Object.Spawn("LightRed",this.Pos.x,this.Pos.y+0.25)
			MyLight.StoveID = this.Id.u
		end
		this.SetInterfaceCaption("toggleLightColour", "tooltip_toggleStoveLightRed")
	end
end

function toggleDeleteClicked()
	for j = 1, #MyStuff do
		for thatStuff in next, Find(this,MyStuff[j],2) do
			if thatStuff.StoveID == this.Id.u then thatStuff.Delete() end
		end
	end
	this.Delete()
end
