
local timeTot = 0
local timePerUpdate = 0.5

local Set = Object.SetProperty
local Get = Object.GetProperty
local Find = Object.GetNearbyObjects
	
local TreeTypes = { "Tree", "SpookyTree", "SnowyConiferTree", "CactusTree", "SakuraTree", "PalmTree", "Bush" }

local FloorTypeCurrent = { [1] = "Current" }
					
local FloorTypesWater = { [1] = "Water",
					[2] = "WaterShallow",
					[3] = "WaterWalkable"
					}
										
local FloorTypesWater2018 = { [1] = "Water",
					[2] = "BorderWater",
					[3] = "WaterStable"
					}
					
local FloorTypesRoad = { [1] = "Road",
					[2] = "RoadMarkings",
					[3] = "RoadMarkingsLeft",
					[4] = "RoadMarkingsRight",
					[5] = "RoadCrossing",
					[6] = "RoadCrossingLeft",
					[7] = "RoadCrossingRight"
					}
					
local FloorTypesDefault = { [1] = "Dirt",
					[2] = "Snow",
					[3] = "PavingStone",
					[4] = "Grass",
					[5] = "LongGrass",
					[6] = "Mud",
					[7] = "Gravel",
					[8] = "Stone",
					[9] = "ConcreteTiles",
					[10] = "ConcreteFloor",
					[11] = "WoodenFloor",
					[12] = "CeramicFloor",
					[13] = "MosaicFloor",
					[14] = "MetalFloor",
					[15] = "Sand",
					[16] = "MarbleTiles",
					[17] = "WhiteTiles",
					[18] = "FancyTiles",
					[19] = "Water",
					[20] = "BurntFloor",
					[21] = "Cobblestone",
					[22] = "LooseStone"
					}
					
local WallTypesDefault = { [1] = "Fence",
					[2] = "ConcreteWall",
					[3] = "BrickWall",
					[4] = "PerimeterWall",
					[5] = "BurntWall",
					[6] = "cinderbwall"
					}

local FloorTypesDLC = { [1] = "NewIronFloor",
					[2] = "NewCargoFloor",
					[3] = "NewCheckeredFloor",
					[4] = "NewMud",
					[5] = "Sandstone",
					[6] = "LunarFloor",
					[7] = "GrassCornerFloor",
					[8] = "GrassCornerFloor1",
					[9] = "GrassCornerFloor2",
					[10] = "GrassCornerFloor3",
					[11] = "GrassStones",
					[12] = "PaddedFloor",
					[13] = "LimestoneFloor",
					[14] = "SolacoFloor",
					[15] = "GrateFloor",
					[16] = "BlueCarpet",
					[17] = "BrownCarpet",
					[18] = "RedCarpet",
					[19] = "RunningTrack",
					[20] = "BambooFloor",
					[21] = "FlowerField",
					[22] = "WoodenDockFloor"
					}
					
local WallTypesDLC = { [1] = "NewBarredWall",
					[2] = "NewTiledWall",
					[3] = "NewHedgeWall",
					[4] = "NewBBlockWall",
					[5] = "YutaniWall",
					[6] = "ArtDecoWall",
					[7] = "OrientalWall",
					[8] = "BlueWall",
					[9] = "BurgundyWall",
					[10] = "CushionedWall",
					[11] = "GreenWall",
					[12] = "DerelictWall",
					[13] = "OvergrownWall",
					[14] = "RustyWall",
					[15] = "SlumWall",
					[16] = "BambooFence",
					[17] = "DecayedWall",
					[18] = "FenceAndGrass",
					[19] = "WallMinSec",
					[20] = "WallMedSec",
					[21] = "WallMaxSec",
					[22] = "WallInsaneSec",
					[23] = "WallProtective",
					[24] = "CliffEdge"
					}
					
local TypesInMemory = { [1] = "Stored" } 

local SelectedGroup = {}
local GroupNr = 1

-- local DepthTable = {}
-- local Round = 1

function Create()
	Set(this,"TileDecay","Clean")
	Set(this,"Indoor","No")
	Set(this,"Ind",false)
	Set(this,"Action","Move")
	Set(this,"Walk",false)
	Set(this,"DepthAmount",1)
	Set(this,"TileDep",0.0001)
	Set(this,"Direction","None")
	DetectGameVersion()
	FindCurrentTileType()
	InitButtons()
	ButtonsMade = true
end

function Update(timePassed)
	if not ButtonsMade then this.Delete() end
	timeTot = timeTot + timePassed
	if timeTot >= timePerUpdate then
		timeTot = 0
		if Get(this,"Walk") == true then
			if this.Direction == "Up" then MaterialDuperUpClicked()
			elseif this.Direction == "Down" then MaterialDuperDownClicked()
			elseif this.Direction == "Left" then MaterialDuperLeftClicked()
			elseif this.Direction == "Right" then MaterialDuperRightClicked()
			end
		end
	end
end

function DetectGameVersion()
	local OrigCell = World.GetCell(0,0)
	local OrigMat = OrigCell.Mat
	print(OrigMat)
	OrigCell.Mat = "GrassCornerFloor"
	local NewCell = World.GetCell(0,0)
	local Result = NewCell.Mat
	print(Result)
	if Result == OrigMat then
		print("Anniversary 2018 edition found")
		Set(this,"Tooltip","tooltip_FloorEditorA")
		AllGroups = { FloorTypeCurrent, FloorTypesRoad, FloorTypesWater2018, FloorTypesDefault, WallTypesDefault, TypesInMemory }
		AllGroupsDesc = { [1] = "Current", [2] = "RoadTiles", [3] = "WaterTiles2018", [4] = "DefaultFloors", [5] = "DefaultWalls", [6] = "Stored" }
		Is2018Edition = true
	else
		print("The Rock edition found")
		Set(this,"Tooltip","tooltip_FloorEditorB")
		AllGroups = { FloorTypeCurrent, FloorTypesRoad, FloorTypesWater, FloorTypesDefault, WallTypesDefault, FloorTypesDLC, WallTypesDLC, TypesInMemory }
		AllGroupsDesc = { [1] = "Current", [2] = "RoadTiles", [3] = "WaterTiles", [4] = "DefaultFloors", [5] = "DefaultWalls", [6] = "DLCFloors", [7] = "DLCWalls", [8] = "Stored" }
	end
	NewCell.Mat = OrigMat
	local x = math.floor(this.Pos.x)
	local y = math.floor(this.Pos.y)
	local cell = World.GetCell(x,y)
	TypesInMemory[1] = cell.Mat
end

function FindCurrentTileType()
	local x = math.floor(this.Pos.x)
	local y = math.floor(this.Pos.y)
	local cell = World.GetCell(x,y)
	CurrentTile = cell.Mat
	SelectedTile = cell.Mat
	if cell.Ind == true then
		Set(this,"Indoor","Yes")
		Set(this,"Ind",true)
	else
		Set(this,"Indoor","No")
		Set(this,"Ind",false)
	end
	FloorTypeCurrent[1] = CurrentTile
	Set(this,"TileNum",1)
	Set(this,"TileType","Current")
	SelectedGroup = FloorTypeCurrent
	GroupNr = 1
	local found = false
	for T = 2,#AllGroups do
		for N = 1,#AllGroups[T] do
			if AllGroups[T][N] == CurrentTile then
				Set(this,"TileNum",N)
				GroupNr = T
				Set(this,"TileType",AllGroupsDesc[GroupNr])
				SelectedGroup = AllGroups[GroupNr]
				if this.TileType == "WaterTiles" then
					Set(this,"TileDep",cell.Dep)
					if N == 3 then
						local D = math.floor(this.TileDep / 0.0007)			-- don't take these numbers for granted, I see no logic in the Dep value
						if D < 0 then D = 0 elseif D > 20 then D = 20 end	-- My buttons set depth in 20 steps, this results in WalkableWater having max depth of 0.015
						Set(this,"DepthAmount",D)
					elseif N == 2 then
						local D = math.floor(this.TileDep / 0.00125)		-- maximum depth for ShallowWater will be 0.025
						if D < 0 then D = 0 elseif D > 20 then D = 20 end
						Set(this,"DepthAmount",D)
					else
						local D = math.floor(this.TileDep / 0.0025)
						if D < 0 then D = 0 elseif D > 20 then D = 20 end	-- maximum depth for Water is 0.05, the only stable number that can be found in savedgame
						Set(this,"DepthAmount",D)
					end
				end
				found = true
				break
			end
		end
		if found then break end
	end
	this.SetInterfaceCaption("toggleStoreInMemory", "tooltip_Button_StoreInMemory")
	this.SetInterfaceCaption("toggleCon", "tooltip_Button_DecaySet")
	this.SetInterfaceCaption("Caption_DecayType", "tooltip_Caption_DecayType",cell.Con,"X")
end

function UpdateTileAndButtons()
	RemoveButtons()
	FindCurrentTileType()
	AddButtons()
	if this.TileType == "WaterTiles" then
		this.SetInterfaceCaption("Caption_DepType", "tooltip_Caption_DepType",this.TileDep,"X")
	end
	this.SetInterfaceCaption("Caption_TileGroup", "tooltip_Button_Group","tooltip_Button_Type"..this.TileType,"X")
	this.SetInterfaceCaption("Caption_ActiveTileType", "tooltip_Caption_ActiveTileType","material_"..SelectedGroup[this.TileNum],"X")
end

function InitButtons()
	Interface.AddComponent(this,"Caption_Using", "Caption", "tooltip_Caption_Using")
	Interface.AddComponent(this,"Caption_ActiveTileType", "Caption", "tooltip_Caption_ActiveTileType","material_"..SelectedGroup[this.TileNum],"X")
	Interface.AddComponent(this,"toggleTileTypePlus", "Button", "tooltip_Button_TileTypePlus")
	Interface.AddComponent(this,"toggleTileTypeMinus", "Button", "tooltip_Button_TileTypeMinus")
	Interface.AddComponent(this,"toggleIndoor", "Button", "tooltip_Button_Indoor"..this.Indoor)
	Interface.AddComponent(this,"toggleStoreInMemory", "Button", "tooltip_Button_StoreInMemory")
	Interface.AddComponent(this,"Caption_Divider1", "Caption", "tooltip_Caption_Group")
	Interface.AddComponent(this,"Caption_TileGroup", "Caption", "tooltip_Button_Group","tooltip_Button_Type"..this.TileType,"X")
	Interface.AddComponent(this,"toggleGroupPlus", "Button", "tooltip_Button_GroupPlus")
	Interface.AddComponent(this,"toggleGroupMinus", "Button", "tooltip_Button_GroupMinus")
	Interface.AddComponent(this,"toggleGroupMemory", "Button", "tooltip_Button_GroupMemory")
	Interface.AddComponent(this,"Caption_Divider2", "Caption", "tooltip_Caption_Divider")
	Interface.AddComponent(this,"toggleAction", "Button", "tooltip_Button_MaterialDuper_Action","tooltip_Button_MaterialDuper_Action"..this.Action,"X")
	Interface.AddComponent(this,"MaterialDuperUp", "Button", "tooltip_Button_MaterialDuper_Up",this.Action,"X")
	Interface.AddComponent(this,"MaterialDuperDown", "Button", "tooltip_Button_MaterialDuper_Down",this.Action,"X")
	Interface.AddComponent(this,"MaterialDuperLeft", "Button", "tooltip_Button_MaterialDuper_Left",this.Action,"X")
	Interface.AddComponent(this,"MaterialDuperRight", "Button", "tooltip_Button_MaterialDuper_Right",this.Action,"X")
	Interface.AddComponent(this,"toggleWalking", "Button", "tooltip_Button_StopWalking")
	Interface.AddComponent(this,"Caption_Decay", "Caption", "tooltip_Caption_Decay")
	Interface.AddComponent(this,"toggleCon", "Button", "tooltip_Button_Decay"..this.TileDecay)
	Interface.AddComponent(this,"Caption_DecayType", "Caption", "tooltip_Caption_DecayType",this.TileDecay,"X")
	AddButtons()
end

function AddButtons()
	if this.TileType == "RoadTiles" then
		Set(this,"Ind",false)
		Set(this,"Indoor","No")
		this.SetInterfaceCaption("toggleIndoor", "tooltip_Button_Indoor"..this.Indoor)
	elseif this.TileType == "WaterTiles" then
		Set(this,"Ind",false)
		Set(this,"Indoor","No")
		this.SetInterfaceCaption("toggleIndoor", "tooltip_Button_Indoor"..this.Indoor)
		Interface.AddComponent(this,"Caption_ChangeDepth", "Caption", "tooltip_Caption_Depth")
		Interface.AddComponent(this,"Caption_DepthAmount", "Button", "tooltip_Button_DepthAmount","tooltip_Button_DepthAmount"..this.DepthAmount,"X")
		Interface.AddComponent(this,"Caption_DepType", "Caption", "tooltip_Caption_DepType",this.TileDep,"X")
		Interface.AddComponent(this,"toggleDepthAmountPlus", "Button", "tooltip_Button_DepthAmountPlus")
		Interface.AddComponent(this,"toggleDepthAmountMinus", "Button", "tooltip_Button_DepthAmountMinus")
	elseif this.TileType == "DefaultFloors" or this.TileType == "DLCFloors" then
		Interface.AddComponent(this,"Caption_ChangeBorder", "Caption", "tooltip_Caption_ChangeBorder")
		Interface.AddComponent(this,"toggleBorderType", "Button", "tooltip_Button_ChangeBorder")
	end
end

function RemoveButtons()
	Interface.RemoveComponent(this,"Caption_ChangeBorder")
	Interface.RemoveComponent(this,"toggleBorderType")
	Interface.RemoveComponent(this,"Caption_ChangeDepth")
	Interface.RemoveComponent(this,"Caption_DepType")
	Interface.RemoveComponent(this,"Caption_DepthAmount")
	Interface.RemoveComponent(this,"toggleDepthAmountPlus")
	Interface.RemoveComponent(this,"toggleDepthAmountMinus")
end

function toggleTileTypePlusClicked()
	Set(this,"TileNum",this.TileNum + 1)
	if this.TileNum > #SelectedGroup then Set(this,"TileNum",1) end
	if this.TileType == "WaterTiles" then
		if this.TileNum == 1	 then Set(this,"TileDep",0.025)
		elseif this.TileNum == 2 then Set(this,"TileDep",0.015)
		elseif this.TileNum == 3 then Set(this,"TileDep",0.0001)
		end
		Set(this,"DepthAmount",1)
		SetTile(SelectedGroup[this.TileNum])
		this.SetInterfaceCaption("Caption_DepthAmount", "tooltip_Button_DepthAmount","tooltip_Button_DepthAmount"..this.DepthAmount,"X")
	else
		SetTile(SelectedGroup[this.TileNum])
	end
	this.SetInterfaceCaption("Caption_ActiveTileType", "tooltip_Caption_ActiveTileType","material_"..SelectedGroup[this.TileNum],"X")
end

function toggleTileTypeMinusClicked()
	Set(this,"TileNum",this.TileNum - 1)
	if this.TileNum < 1 then Set(this,"TileNum",#SelectedGroup) end
	if this.TileType == "WaterTiles" then
		if this.TileNum == 1	 then Set(this,"TileDep",0.025)
		elseif this.TileNum == 2 then Set(this,"TileDep",0.015)
		elseif this.TileNum == 3 then Set(this,"TileDep",0.0001)
		end
		Set(this,"DepthAmount",1)
		SetTile(SelectedGroup[this.TileNum])
		this.SetInterfaceCaption("Caption_DepthAmount", "tooltip_Button_DepthAmount","tooltip_Button_DepthAmount"..this.DepthAmount,"X")
	else
		SetTile(SelectedGroup[this.TileNum])
	end
	this.SetInterfaceCaption("Caption_ActiveTileType", "tooltip_Caption_ActiveTileType","material_"..SelectedGroup[this.TileNum],"X")
end

function toggleGroupPlusClicked()
	RemoveButtons()
	Set(this,"TileNum",1)
	GroupNr = GroupNr + 1
	if GroupNr > #AllGroups then GroupNr = 1 end
	Set(this,"TileType",AllGroupsDesc[GroupNr])
	SelectedGroup = AllGroups[GroupNr]
	AddButtons()
	SetTile(SelectedGroup[this.TileNum])
	this.SetInterfaceCaption("Caption_TileGroup", "tooltip_Button_Group","tooltip_Button_Type"..this.TileType,"X")
	this.SetInterfaceCaption("Caption_ActiveTileType", "tooltip_Caption_ActiveTileType","material_"..SelectedGroup[this.TileNum],"X")
end

function toggleGroupMinusClicked()
	RemoveButtons()
	Set(this,"TileNum",1)
	GroupNr = GroupNr - 1
	if GroupNr < 1 then GroupNr = #AllGroups end
	Set(this,"TileType",AllGroupsDesc[GroupNr])
	SelectedGroup = AllGroups[GroupNr]
	AddButtons()
	SetTile(SelectedGroup[this.TileNum])
	this.SetInterfaceCaption("Caption_TileGroup", "tooltip_Button_Group","tooltip_Button_Type"..this.TileType,"X")
	this.SetInterfaceCaption("Caption_ActiveTileType", "tooltip_Caption_ActiveTileType","material_"..SelectedGroup[this.TileNum],"X")
end

function toggleGroupMemoryClicked()
	RemoveButtons()
	Set(this,"TileNum",1)
	Set(this,"TileType","Stored")
	SelectedGroup = TypesInMemory
	AddButtons()
	SetTile(SelectedGroup[this.TileNum])
	this.SetInterfaceCaption("Caption_TileGroup", "tooltip_Button_Group","tooltip_Button_Type"..this.TileType,"X")
	this.SetInterfaceCaption("Caption_ActiveTileType", "tooltip_Caption_ActiveTileType","material_"..SelectedGroup[this.TileNum],"X")
end

function toggleStoreInMemoryClicked()
	local duplicate = false
	for i = 1, #TypesInMemory do
		if TypesInMemory[i] == CurrentTile then
			duplicate = true
			break
		end
	end
	if duplicate == false then
		table.insert(TypesInMemory,CurrentTile)
		table.sort(TypesInMemory) --- sorts the stored tilenames A-Z
		this.SetInterfaceCaption("toggleStoreInMemory", "tooltip_Button_StoreInMemoryDone")
	else
		this.SetInterfaceCaption("toggleStoreInMemory", "tooltip_Button_StoreInMemoryDuplicate")
	end
end

function toggleWalkingClicked()
	if Get(this,"Walk") == true then
		Set(this,"Walk",false)
		Set(this,"Direction","None")
		this.SetInterfaceCaption("toggleWalking", "tooltip_Button_StopWalking")
	else
		Set(this,"Walk",true)
		this.SetInterfaceCaption("toggleWalking", "tooltip_Button_StartWalking")
	end
end

function StopWalking()
	print("StopWalking")
	Set(this,"Walk",false)
	Set(this,"Direction","None")
	this.SetInterfaceCaption("toggleWalking", "tooltip_Button_StopWalking")
end

function toggleActionClicked()
	if this.Action == "Copy" then
		Set(this,"Action","Move")		
	else
		Set(this,"Action","Copy")
		local x = math.floor(this.Pos.x)
		local y = math.floor(this.Pos.y)
		local cell = World.GetCell(x,y)
		if cell.Ind == true then
			Set(this,"Ind",true)
			Set(this,"Indoor","Yes")
		else
			Set(this,"Ind",false)
			Set(this,"Indoor","No")
		end
		this.SetInterfaceCaption("toggleIndoor", "tooltip_Button_Indoor"..this.Indoor)
	end
	this.SetInterfaceCaption("toggleAction", "tooltip_Button_MaterialDuper_Action","tooltip_Button_MaterialDuper_Action"..this.Action,"X")
	this.SetInterfaceCaption("MaterialDuperUp", "tooltip_Button_MaterialDuper_Up",this.Action,"X")
	this.SetInterfaceCaption("MaterialDuperDown", "tooltip_Button_MaterialDuper_Down",this.Action,"X")
	this.SetInterfaceCaption("MaterialDuperLeft", "tooltip_Button_MaterialDuper_Left",this.Action,"X")
	this.SetInterfaceCaption("MaterialDuperRight", "tooltip_Button_MaterialDuper_Right",this.Action,"X")
end

function MaterialDuperUpClicked()
	if this.Direction ~= "Up" then
		if Get(this,"Walk") == true then toggleWalkingClicked() end
		Set(this,"Or.y",-1)
		Set(this,"Or.x",0)
		Set(this,"Direction","Up")
		this.NavigateTo(this.Pos.x,this.Pos.y)	-- seems to be needed to rotate the sprite immediately
	else
		if this.Pos.y >= 1 then
			this.Pos.y = math.floor(this.Pos.y) - 0.5
			if this.Action == "Copy" then
				SetTile(SelectedGroup[this.TileNum])
			else
				UpdateTileAndButtons()
			end
		else
			StopWalking()
		end
	end
end

function MaterialDuperDownClicked()
	if this.Direction ~= "Down" then
		if Get(this,"Walk") == true then toggleWalkingClicked() end
		Set(this,"Or.y",1)
		Set(this,"Or.x",0)
		Set(this,"Direction","Down")
		this.NavigateTo(this.Pos.x,this.Pos.y)
	else
		if this.Pos.y < World.NumCellsY - 1 then
			this.Pos.y = math.floor(this.Pos.y) + 1.5
			if this.Action == "Copy" then
				SetTile(SelectedGroup[this.TileNum])
			else
				UpdateTileAndButtons()
			end
		else
			StopWalking()
		end
	end
end

function MaterialDuperLeftClicked()
	if this.Direction ~= "Left" then
		if Get(this,"Walk") == true then toggleWalkingClicked() end
		Set(this,"Or.x",-1)
		Set(this,"Or.y",0)
		Set(this,"Direction","Left")
		this.NavigateTo(this.Pos.x,this.Pos.y)
	else
		if this.Pos.x >= 1 then
			this.Pos.x = this.Pos.x - 1
			if this.Action == "Copy" then
				SetTile(SelectedGroup[this.TileNum])
			else
				UpdateTileAndButtons()
			end
		else
			StopWalking()
		end
	end
end

function MaterialDuperRightClicked()
	if this.Direction ~= "Right" then
		if Get(this,"Walk") == true then toggleWalkingClicked() end
		Set(this,"Or.x",1)
		Set(this,"Or.y",0)
		Set(this,"Direction","Right")
		this.NavigateTo(this.Pos.x,this.Pos.y)
	else
		if this.Pos.x < World.NumCellsX - 1 then
			this.Pos.x = this.Pos.x + 1
			if this.Action == "Copy" then
				SetTile(SelectedGroup[this.TileNum])
			else
				UpdateTileAndButtons()
			end
		else
			StopWalking()
		end
	end
end

function toggleConClicked()
	if this.TileDecay == "Clean" then Set(this,"TileDecay","Dirty")
	elseif this.TileDecay == "Dirty" then Set(this,"TileDecay","Filthy")
	elseif this.TileDecay == "Filthy" then Set(this,"TileDecay","Disgusting")
	elseif this.TileDecay == "Disgusting" then Set(this,"TileDecay","Clean")
	end
	SetTile(SelectedGroup[this.TileNum])
	this.SetInterfaceCaption("toggleCon", "tooltip_Button_Decay"..this.TileDecay)
end

function toggleIndoorClicked()
	if this.Ind == true then
		Set(this,"Ind",false)
		Set(this,"Indoor","No")
	else
		Set(this,"Ind",true)
		Set(this,"Indoor","Yes")
	end
	SetTile(SelectedGroup[this.TileNum])
	this.SetInterfaceCaption("toggleIndoor", "tooltip_Button_Indoor"..this.Indoor)
end

function toggleDepthAmountPlusClicked()
	this.DepthAmount = this.DepthAmount + 1
	if this.DepthAmount > 20 then this.DepthAmount = 0 end
	if SelectedGroup[this.TileNum] == "WaterWalkable"	 then Set(this,"TileDep",0.0007*this.DepthAmount)
	elseif SelectedGroup[this.TileNum] == "WaterShallow" then Set(this,"TileDep",0.00125*this.DepthAmount)
	elseif SelectedGroup[this.TileNum] == "Water"		 then Set(this,"TileDep",0.0025*this.DepthAmount)
	end		
	SetTile(SelectedGroup[this.TileNum])
	this.SetInterfaceCaption("Caption_DepthAmount", "tooltip_Button_DepthAmount","tooltip_Button_DepthAmount"..this.DepthAmount,"X")
end

function toggleDepthAmountMinusClicked()
	this.DepthAmount = this.DepthAmount - 1
	if this.DepthAmount < 0 then this.DepthAmount = 20 end
	if SelectedGroup[this.TileNum] == "WaterWalkable"	 then Set(this,"TileDep",0.0007*this.DepthAmount)
	elseif SelectedGroup[this.TileNum] == "WaterShallow" then Set(this,"TileDep",0.00125*this.DepthAmount)
	elseif SelectedGroup[this.TileNum] == "Water"		 then Set(this,"TileDep",0.0025*this.DepthAmount)
	end		
	SetTile(SelectedGroup[this.TileNum])
	this.SetInterfaceCaption("Caption_DepthAmount", "tooltip_Button_DepthAmount","tooltip_Button_DepthAmount"..this.DepthAmount,"X")
end

function toggleRemoveAllTreesClicked()
	Set(this,"Pos.x",EdgeRight/2)
	Set(this,"Pos.y",EdgeBottom/2)
	RemoveTrees(this,10000)
	Interface.RemoveComponent(this,"toggleRemoveAllTrees")
end

function SetTile(TileType)
	local x = math.floor(this.Pos.x)
	local y = math.floor(this.Pos.y)
	local cell = World.GetCell(x,y)
	print(cell.WorldCellMetaTable.CellGetterTable)
	cell.Mat = TileType
	cell.Ind = this.Ind
	CurrentTile = cell.Mat
	if this.TileDecay == "Clean" then			 cell.Con = 100
	elseif this.TileDecay == "Dirty" then		 cell.Con = math.random(67,99)
	elseif this.TileDecay == "Filthy" then		 cell.Con = math.random(34,66)
	elseif this.TileDecay == "Disgusting" then	 cell.Con = math.random(1,33)
	end
	this.SetInterfaceCaption("Caption_DecayType", "tooltip_Caption_DecayType",cell.Con,"X")
	if this.TileType == "WaterTiles" then
		cell.Dep = this.TileDep
		this.SetInterfaceCaption("Caption_DepType", "tooltip_Caption_DepType",cell.Dep,"X")
	end
	this.SetInterfaceCaption("toggleStoreInMemory", "tooltip_Button_StoreInMemory")
end

function toggleCheatsClicked()
	if World.CheatsEnabled == true then
		World.ImmediateMaterials = false
		World.ImmediateTerrain = false
		World.CheatsEnabled = false
		this.SetInterfaceCaption("toggleCheats", "tooltip_Button_ToggleCheatsOff")
	else
		World.CheatsEnabled = true
		World.ImmediateMaterials = true
		World.ImmediateTerrain = true
		this.SetInterfaceCaption("toggleCheats", "tooltip_Button_ToggleCheatsOn")
	end
end

function toggleBorderTypeClicked()
	MakeBorder(SelectedGroup[this.TileNum])
end

function MakeBorder(BorderType)
	local endX = 0
	local endY = -1
	local foundEndX=false
	local foundEndY=false
	local Decay = 0
	local SetEdgeTile = BorderType
	if Is2018Edition == true and this.TileType == "WaterTiles2018" then
		SetEdgeTile = "BorderWater"
	end
	if this.TileDecay == "Clean" then			 Decay = 100
	elseif this.TileDecay == "Dirty" then		 Decay = math.random(67,99)
	elseif this.TileDecay == "Filthy" then		 Decay = math.random(34,66)
	elseif this.TileDecay == "Disgusting" then	 Decay = math.random(1,33)
	end
	
	while foundEndY == false do	-- left map edge
		endY = endY + 1
		local cell = World.GetCell(0,endY)
		if cell.Mat ~= nil then
			cell.Mat = SetEdgeTile
			cell.Con = Decay
			cell.Ind = false
		else
			endY = endY - 1
			foundEndY = true
		end
	end

	while foundEndX == false do	-- top & bottom map edge
		endX = endX + 1
		local TopRowCell = World.GetCell(endX,0)
		local BottomRowCell = World.GetCell(endX,endY)
		if TopRowCell.Mat ~= nil then
			if TopRowCell.Mat == "RoadMarkingsLeft" then
				local prevTopRowCell = World.GetCell(endX-1,0)
				local prevBottomRowCell = World.GetCell(endX-1,endY)
				prevTopRowCell.Mat = "ConcreteTiles"
				prevBottomRowCell.Mat = "ConcreteTiles"
				local SingleLaneRoadCheck = World.GetCell(endX+1,0)
				if SingleLaneRoadCheck.Mat == "RoadMarkingsRight" then
					endX = endX + 2
				else
					endX = endX + 5
				end
			else
				TopRowCell.Mat = SetEdgeTile
				BottomRowCell.Mat = SetEdgeTile
				TopRowCell.Con = Decay
				BottomRowCell.Con = Decay
				TopRowCell.Ind = false
				BottomRowCell.Ind = false
			end
		else
			endX = endX - 1
			foundEndX = true
		end
		
	end
	
	for i=0,endY do	-- right map edge
		local cell = World.GetCell(endX,i)
		cell.Mat = SetEdgeTile
		cell.Con = Decay
		cell.Ind = false
 	end
	
end

function RemoveTrees(from,dist)
	for j = 1, #TreeTypes do
		for thatTree in next, Find(from,TreeTypes[j],dist) do
			local cell = World.GetCell(thatTree.Pos.x,thatTree.Pos.y)
			if cell.Mat == "Water" or cell.Mat == "WaterShallow" then
				thatTree.Delete()
			end
		end
	end
end
