
local timeTot = 0
local timePerUpdate = 0.1 / World.TimeWarpFactor

local Set = Object.SetProperty
local Get = Object.GetProperty
local Find = Object.GetNearbyObjects
	
local TreeTypes = {
		[0] = "Tree",
		[1] = "Oak",
		[2] = "Fir",
		[3] = "Chestnut",
		[4] = "Conifer",
		[5] = "Palm",
		[6] = "Mixed",
		[7] = "SpookyTree",
		[8] = "SnowyConiferTree",
		[9] = "CactusTree",
		[10] = "SakuraTree",
		[11] = "PalmTree",
		[12] = "Bush"
		}

local TreeTypes2018 = {
		[0] = "Tree",
		[1] = "Oak",
		[2] = "Fir",
		[3] = "Chestnut",
		[4] = "Conifer",
		[5] = "Palm",
		[6] = "Mixed"
		}

local DepthTable = {}
local BackupTable = {}
local Round = 1
local BeachRound = 1
local Multiplier = 1
local MakeCoastLine = true
local CoastLineMade = false
local CoastDirt = 0
local CoastSand = 0
local CoastStone = 0
local CoastGrass = 0
local CoastBeach = 0
local CoastCustom = 0
local CoastWalkable = 1
local CoastShallow = 1
local CoastDeep = 1
local IslandType = 0
local MakeBeachTrees = true
local TreeType = 5
local TreeAmount = 25
local MakeBeach = true
local BeachType = 0
local RoadBarriers = false
local GateType = "RoadBarrier"
local MakeBridges = false
local NextPillar = 8
local MakeReef = false
local CreateWaterMap = false
local CreateBeachMap = false
local PlotWaterDepth = false
local UndoPlotting = false
local AutoPlotting = false
local SideWalk = "L" -- "N" == no sidewalks, "L" = left, "R" = right, "LR" = both sides of road

local IslandTypes = {
		[0] = "Current",
		[1] = "Dirt",
		[2] = "Snow",
		[3] = "PavingStone",
		[4] = "Grass",
		[5] = "LongGrass",
		[6] = "Mud",
		[7] = "Gravel",
		[8] = "Stone",
		[9] = "ConcreteTiles",
		[10] = "Sand",
		[11] = "LooseStone",
		[12] = "NewMud",
		[13] = "Sandstone",
		[14] = "LunarFloor",
		[15] = "GrassStones",
		[16] = "FlowerField"
	}

local IslandTypes2018 = {
		[0] = "Current",
		[1] = "Dirt",
		[2] = "PavingStone",
		[3] = "Grass",
		[4] = "LongGrass",
		[5] = "Mud",
		[6] = "Gravel",
		[7] = "Stone",
		[8] = "ConcreteTiles",
		[9] = "Sand",
		[10] = "LooseStone"
	}

local BridgeLR = {
		[1] = { 0, 8, 1, 2, 2, 3, 4, 5, 7, 5, 6, 3, 2, 2, 1, 8, 0 },	-- bridge with a RoadMarkings tile in the centre, sidewalk L + R
		[2] = { 0, 8, 1, 2, 2, 3, 4, 5, 5, 5, 6, 3, 2, 2, 1, 8, 0 }	-- bridge without RoadMarkings, sidewalk L + R
	}
	
local BridgeL = {
		[1] = { 0, 8, 1, 2, 2, 3, 4, 5, 7, 5, 6, 3, 1, 8, 0, 0, 0 },	-- bridge with a RoadMarkings tile in the centre, sidewalk on left side
		[2] = { 0, 8, 1, 2, 2, 3, 4, 5, 5, 5, 6, 3, 1, 8, 0, 0, 0 }
	}
	
local BridgeR = {
		[1] = { 0, 0, 0, 8, 1, 3, 4, 5, 7, 5, 6, 3, 2, 2, 1, 8, 0 },	-- bridge with a RoadMarkings tile in the centre, sidewalk on left side
		[2] = { 0, 0, 0, 8, 1, 3, 4, 5, 5, 5, 6, 3, 2, 2, 1, 8, 0 }
	}
	
local Bridge = {
		[1] = { 0, 0, 0, 8, 1, 3, 4, 5, 7, 5, 6, 3, 1, 8, 0, 0, 0 },	-- bridge with a RoadMarkings tile in the centre, sidewalk on left side
		[2] = { 0, 0, 0, 8, 1, 3, 4, 5, 5, 5, 6, 3, 1, 8, 0, 0, 0 }
	}
	
local BridgePillarLR = {
		[1] = { 8, 1, 1, 2, 2, 3, 4, 5, 7, 5, 6, 3, 2, 2, 1, 1, 8 },	-- bridge with pillars and a RoadMarkings tile in the centre, sidewalk L + R
		[2] = { 8, 1, 1, 2, 2, 3, 4, 5, 5, 5, 6, 3, 2, 2, 1, 1, 8 }	-- bridge with pillars but without RoadMarkings, sidewalk L + R
	}
	
local BridgePillarL = {
		[1] = { 8, 1, 1, 2, 2, 3, 4, 5, 7, 5, 6, 3, 1, 1, 8, 0, 0 },
		[2] = { 8, 1, 1, 2, 2, 3, 4, 5, 5, 5, 6, 3, 1, 1, 8, 0, 0 }
	}
	
local BridgePillarR = {
		[1] = { 0, 0, 8, 1, 1, 3, 4, 5, 7, 5, 6, 3, 2, 2, 1, 1, 8 },
		[2] = { 0, 0, 8, 1, 1, 3, 4, 5, 5, 5, 6, 3, 2, 2, 1, 1, 8 }
	}
	
local BridgePillar = {
		[1] = { 0, 0, 8, 1, 1, 3, 4, 5, 7, 5, 6, 3, 1, 1, 8, 0, 0 },
		[2] = { 0, 0, 8, 1, 1, 3, 4, 5, 5, 5, 6, 3, 1, 1, 8, 0, 0 }
	}
	
local NoBridgeLR = {
		[1] = { 0, 0, 8, 2, 2, 3, 4, 5, 7, 5, 6, 3, 2, 2, 8, 0, 0 },
		[2] = { 0, 0, 8, 2, 2, 3, 4, 5, 5, 5, 6, 3, 2, 2, 8, 0, 0 }
	}
	
local NoBridgeL = {
		[1] = { 0, 0, 8, 2, 2, 3, 4, 5, 7, 5, 6, 3, 8, 0, 0, 0, 0 },
		[2] = { 0, 0, 8, 2, 2, 3, 4, 5, 5, 5, 6, 3, 8, 0, 0, 0, 0 }
	}
	
local NoBridgeR = {
		[1] = { 0, 0, 0, 0, 8, 3, 4, 5, 7, 5, 6, 3, 2, 2, 8, 0, 0 },
		[2] = { 0, 0, 0, 0, 8, 3, 4, 5, 5, 5, 6, 3, 2, 2, 8, 0, 0 }
	}
	
local NoBridge = {
		[1] = { 0, 0, 0, 0, 8, 3, 4, 5, 7, 5, 6, 3, 8, 0, 0, 0, 0 },
		[2] = { 0, 0, 0, 0, 8, 3, 4, 5, 5, 5, 6, 3, 8, 0, 0, 0, 0 }
	}
	
local BridgeTiles = {
		[0] = "Empty", -- 0 = excluded from changing
		[1] = "ConcreteWall",
		[2] = "PavingStone",
		[3] = "ConcreteTiles",
		[4] = "RoadMarkingsLeft",
		[5] = "Road",
		[6] = "RoadMarkingsRight",
		[7] = "RoadMarkings",
		[8] = "Water" --"WaterShallow"
	}
	
local BridgeTilesBackup = {
		{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
		{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
		{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
		{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }
	}


local WaterTiles = { "WaterWalkable", "WaterShallow", "Water", "Water", "Water", "Water" }
local WaterTiles2018 = { "BorderWater", "BorderWater", "Water", "Water", "Water", "Water" }

local ReefTiles = { "LooseStone", "Gravel", "LooseStone", "LooseStone" }

local BeachTiles = {
		[0] = "Sand", 
		[1] = "LooseStone",
		[2] = "Dirt",
		[3] = "Mud",
		[4] = "Snow",
		[5] = "Grass",
		[6] = "LongGrass",
		[7] = "Gravel",
		[8] = "PavingStone",
		[9] = "Stone",
		[10] = "ConcreteTiles",
		[11] = "NewMud",
		[12] = "Sandstone",
		[13] = "LunarFloor",
		[14] = "GrassStones",
		[15] = "FlowerField"
	}

local BeachTiles2018 = {
		[0] = "Sand", 
		[1] = "LooseStone",
		[2] = "Dirt",
		[3] = "Mud",
		[4] = "Grass",
		[5] = "LongGrass",
		[6] = "Gravel",
		[7] = "PavingStone",
		[8] = "Stone",
		[9] = "ConcreteTiles"
	}
	
function Create()
	DetectGameVersion()
	InitButtons()
	ButtonsMade = true
end

function Update(timePassed)
	if not ButtonsMade then this.Delete() end
	timeTot = timeTot + timePassed
	if timeTot >= timePerUpdate then
		timeTot = 0
		if CreateWaterMap == true then
			MakeWaterMap()
			return
		elseif CreateBeachMap == true then
			PlotBeach()
			return
		elseif PlotWaterDepth == true then
			PlotDepth()
			return
		elseif UndoPlotting == true then
			RestartPlotting()
		end
	end
end

function DetectGameVersion()
	local OrigCell = World.GetCell(0,0)
	local OrigMat = OrigCell.Mat
	print(OrigMat)
	OrigCell.Mat = "GrassCornerFloor"
	local NewCell = World.GetCell(0,0)
	local Result = NewCell.Mat
	print(Result)
	if Result == OrigMat then
		print("Anniversary 2018 edition found")
		WaterTiles = WaterTiles2018
		IslandTypes = IslandTypes2018
		BeachTiles = BeachTiles2018
		TreeTypes = TreeTypes2018
		Is2018Edition = true
	else
		print("The Rock edition found")
	end
	NewCell.Mat = OrigMat
	OrigCell = nil
	NewCell = nil
	Result = nil
	BackupBridgeTiles()
end

function InitButtons()
	Interface.AddComponent(this,"Caption_IslandDivider1", "Caption", "tooltip_Button_DepthAmount15")
	Interface.AddComponent(this,"Caption_IslandType", "Caption", "tooltip_Caption_IslandType")
	Interface.AddComponent(this,"toggleIslandTypePlus", "Button", "tooltip_Button_TileTypePlus")
	Interface.AddComponent(this,"Caption_ActiveTileType", "Caption", "tooltip_Caption_ActiveTileType","material_"..IslandTypes[IslandType],"X")
	Interface.AddComponent(this,"toggleIslandTypeMinus", "Button", "tooltip_Button_TileTypeMinus")
	Interface.AddComponent(this,"Caption_CreateIslands1", "Caption", "tooltip_Caption_CreateIslands1")
	Interface.AddComponent(this,"Caption_CreateIslands2", "Caption", "tooltip_Caption_CreateIslands2")
	Interface.AddComponent(this,"Caption_CreateIslands3", "Caption", "tooltip_Caption_CreateIslands3")
	Interface.AddComponent(this,"Caption_CreateIslands4", "Caption", "tooltip_Caption_CreateIslands4")
	Interface.AddComponent(this,"toggleStartPlotting", "Button", "tooltip_Button_StartPlotting")
	Interface.AddComponent(this,"Caption_CreateIslands5", "Caption", "tooltip_Caption_CreateIslands5")
	Interface.AddComponent(this,"Caption_IslandDivider2", "Caption", "tooltip_Button_DepthAmount15")
	Interface.AddComponent(this,"toggleBeach", "Button", "tooltip_Button_CreateBeachOn")
	Interface.AddComponent(this,"toggleBeachType", "Button", "tooltip_Button_BeachType","material_"..BeachTiles[BeachType],"X")
	Interface.AddComponent(this,"toggleBeachTrees", "Button", "tooltip_Button_MakeBeachTreesOn")
	Interface.AddComponent(this,"toggleTreeAmount", "Button", "tooltip_Button_TreeAmount",TreeAmount,"X")
	Interface.AddComponent(this,"toggleTreeType", "Button", "tooltip_Button_TreeType",TreeTypes[TreeType],"X")
	Interface.AddComponent(this,"Caption_IslandDivider3", "Caption", "tooltip_Button_DepthAmount15")
	Interface.AddComponent(this,"toggleCreateBridgesPath", "Button", "tooltip_Button_CreateSideWalk"..SideWalk)
	Interface.AddComponent(this,"toggleCreateBridges", "Button", "tooltip_Button_CreateBridgesOff")
	Interface.AddComponent(this,"toggleCreateBridgePillars", "Button", "tooltip_Button_CreateBridgePillars0")
	Interface.AddComponent(this,"Caption_IslandDivider4", "Caption", "tooltip_Button_DepthAmount15")
	Interface.AddComponent(this,"toggleCreateRoadBarriers", "Button", "tooltip_Button_CreateRoadBarriersOff")
	Interface.AddComponent(this,"toggleGateType", "Button", "tooltip_Button_GateType"..GateType)
	Interface.AddComponent(this,"Caption_IslandDivider5", "Caption", "tooltip_Button_DepthAmount15")
	Interface.AddComponent(this,"togglePlotAutoManual", "Button", "tooltip_Button_PlottingManual")
	Set(this,"Tooltip","tooltip_IslandPlotterA")
	endX = 0
	endY = 0
	EdgeRight = World.NumCellsX-2
	EdgeBottom = World.NumCellsY-2
	EdgeTile = "Water"
	PerTick = 10
	TotTick = 0
	Progress = 0
end

function toggleIslandTypePlusClicked()
	IslandType = IslandType + 1
	if IslandType > #IslandTypes then IslandType = 0 end
	this.SetInterfaceCaption("Caption_ActiveTileType", "tooltip_Caption_ActiveTileType","material_"..IslandTypes[IslandType],"X")
end

function toggleIslandTypeMinusClicked()
	IslandType = IslandType - 1
	if IslandType < 0 then IslandType = #IslandTypes end
	this.SetInterfaceCaption("Caption_ActiveTileType", "tooltip_Caption_ActiveTileType","material_"..IslandTypes[IslandType],"X")
end

function toggleStartPlottingClicked()
	Interface.RemoveComponent(this,"Caption_IslandType")
	Interface.RemoveComponent(this,"toggleIslandTypePlus")
	Interface.RemoveComponent(this,"Caption_ActiveTileType")
	Interface.RemoveComponent(this,"toggleIslandTypeMinus")
	Interface.RemoveComponent(this,"Caption_CreateIslands1")
	Interface.RemoveComponent(this,"Caption_CreateIslands2")
	Interface.RemoveComponent(this,"Caption_CreateIslands3")
	Interface.RemoveComponent(this,"Caption_CreateIslands4")
	Interface.RemoveComponent(this,"toggleStartPlotting")
	Interface.RemoveComponent(this,"Caption_CreateIslands5")
	Interface.RemoveComponent(this,"Caption_IslandDivider2")
	Interface.RemoveComponent(this,"toggleBeach")
	Interface.RemoveComponent(this,"toggleBeachType")
	Interface.RemoveComponent(this,"toggleBeachTrees")
	Interface.RemoveComponent(this,"toggleTreeAmount")
	Interface.RemoveComponent(this,"toggleTreeType")
	Interface.RemoveComponent(this,"Caption_IslandDivider3")
	Interface.RemoveComponent(this,"toggleCreateBridgesPath")
	Interface.RemoveComponent(this,"toggleCreateBridges")
	Interface.RemoveComponent(this,"toggleCreateBridgePillars")
	Interface.RemoveComponent(this,"Caption_IslandDivider4")
	Interface.RemoveComponent(this,"toggleCreateRoadBarriers")
	Interface.RemoveComponent(this,"toggleGateType")
	Interface.RemoveComponent(this,"Caption_IslandDivider5")
	Interface.RemoveComponent(this,"togglePlotAutoManual")
	Interface.RemoveComponent(this,"Caption_CoastPlotter")
	Interface.RemoveComponent(this,"toggleReef")
	Interface.RemoveComponent(this,"toggleWaterWalkable")
	Interface.RemoveComponent(this,"toggleWaterShallow")
	Interface.RemoveComponent(this,"toggleWaterDeep")
	Interface.AddComponent(this,"Caption_PlottingRound", "Caption", "tooltip_Caption_PlottingIsland")
	Interface.AddComponent(this,"Caption_WaterPleaseWait", "Caption", "tooltip_Caption_WaterPleaseWait")
	Interface.AddComponent(this,"Caption_WaterInProgress", "Caption", "tooltip_Caption_WaterInProgress"..Progress)
	RestoreBridgeTiles()
	RemoveRoadGates()
	RemoveTrees(this,10000,true)
	endX = 0
	endY = 0
	Set(this,"Pos.x",0)
	Set(this,"Pos.y",0)
	EdgeTile = "Water"
	PerTick = 10
	TotTick = 0
	Progress = 0
	if Is2018Edition == true then
		EdgeTile = "BorderWater"
	end
	table.insert(BackupTable,0)
	BackupTable[0] = {}
	table.insert(DepthTable,0)
	DepthTable[0] = {}
	table.insert(DepthTable[0],0)
	CoastTiles = {}
	if not Is2018Edition then
		if Round == 1		 then table.insert(CoastTiles,"WaterWalkable") end
		if Round == 2		 then table.insert(CoastTiles,"WaterShallow") end
		if Round == 3		 then table.insert(CoastTiles,"Water") end
	elseif Round == 1		 then table.insert(CoastTiles,"BorderWater")
	elseif Round == 2		 then table.insert(CoastTiles,"BorderWater")
	elseif Round == 3		 then table.insert(CoastTiles,"Water")
	end
	if CoastDirt == 1	 then table.insert(CoastTiles,"Dirt") end
	if CoastGrass == 1	 then table.insert(CoastTiles,"LongGrass") end
	if CoastSand == 1	 then table.insert(CoastTiles,"Sand") end
	if CoastStone == 1	 then table.insert(CoastTiles,"LooseStone")end
	if CoastBeach == 1	 then table.insert(CoastTiles,BeachTiles[BeachType]) end
	if CoastCustom == 1 and IslandType > 0 then table.insert(CoastTiles,IslandTypes[IslandType]) end
	AvailableCoastTiles = #CoastTiles
	CreateWaterMap = true
end

function togglePlotAutoManualClicked()
	if AutoPlotting == true then
		AutoPlotting = false
		this.SetInterfaceCaption("togglePlotAutoManual", "tooltip_Button_PlottingManual")
		Interface.RemoveComponent(this,"Caption_CoastPlotter")
		Interface.RemoveComponent(this,"toggleReef")
		Interface.RemoveComponent(this,"toggleWaterWalkable")
		Interface.RemoveComponent(this,"toggleWaterShallow")
		if not Is2018Edition then
			Interface.RemoveComponent(this,"toggleWaterDeep")
		end
	else
		AutoPlotting = true
		this.SetInterfaceCaption("togglePlotAutoManual", "tooltip_Button_PlottingAuto")
		Interface.AddComponent(this,"Caption_CoastPlotter", "Caption", "tooltip_Caption_CoastLine")
		if MakeReef == true then
			Interface.AddComponent(this,"toggleReef", "Button", "tooltip_Button_CoastLineReefOn")
		else
			Interface.AddComponent(this,"toggleReef", "Button", "tooltip_Button_CoastLineReefOff")
		end
		Interface.AddComponent(this,"toggleWaterWalkable", "Button", "tooltip_Button_CoastLineWalkable","tooltip_Button_CoastLine"..CoastWalkable,"X")
		Interface.AddComponent(this,"toggleWaterShallow", "Button", "tooltip_Button_CoastLineShallow","tooltip_Button_CoastLine"..CoastShallow,"X")
		if not Is2018Edition then
			Interface.AddComponent(this,"toggleWaterDeep", "Button", "tooltip_Button_CoastLineDeep","tooltip_Button_CoastLine"..CoastDeep,"X")
		end
	end		
end

function toggleBeachClicked()
	if MakeBeach == true then
		MakeBeach = false
		MakeBeachTrees = false
		this.SetInterfaceCaption("toggleBeach", "tooltip_Button_CreateBeachOff")
		this.SetInterfaceCaption("toggleBeachType", "tooltip_Button_BeachType0")
		this.SetInterfaceCaption("toggleBeachTrees", "tooltip_Button_MakeBeachTreesOff")
		this.SetInterfaceCaption("toggleTreeAmount", "tooltip_Button_TreeAmount0")
		this.SetInterfaceCaption("toggleTreeType", "tooltip_Button_TreeType0")
	else
		MakeBeach = true
		MakeBeachTrees = true
		this.SetInterfaceCaption("toggleBeach", "tooltip_Button_CreateBeachOn")
		this.SetInterfaceCaption("toggleBeachType", "tooltip_Button_BeachType","material_"..BeachTiles[BeachType],"X")
		this.SetInterfaceCaption("toggleBeachTrees", "tooltip_Button_MakeBeachTreesOn")
		this.SetInterfaceCaption("toggleTreeAmount", "tooltip_Button_TreeAmount",TreeAmount,"X")
		this.SetInterfaceCaption("toggleTreeType", "tooltip_Button_TreeType",TreeTypes[TreeType],"X")
	end		
end

function toggleBeachTypeClicked()
	if MakeBeach == true then
		BeachType = BeachType + 1
		if BeachType > #BeachTiles then BeachType = 0 end
		this.SetInterfaceCaption("toggleBeachType", "tooltip_Button_BeachType","material_"..BeachTiles[BeachType],"X")
	end		
end

function toggleBeachTreesClicked()
	if MakeBeach == true then
		if MakeBeachTrees == true then
			MakeBeachTrees = false
			this.SetInterfaceCaption("toggleBeachTrees", "tooltip_Button_MakeBeachTreesOff")
			this.SetInterfaceCaption("toggleTreeAmount", "tooltip_Button_TreeAmount0")
			this.SetInterfaceCaption("toggleTreeType", "tooltip_Button_TreeType0")
		else
			MakeBeachTrees = true
			this.SetInterfaceCaption("toggleBeachTrees", "tooltip_Button_MakeBeachTreesOn")
			this.SetInterfaceCaption("toggleTreeAmount", "tooltip_Button_TreeAmount",TreeAmount,"X")
			this.SetInterfaceCaption("toggleTreeType", "tooltip_Button_TreeType",TreeTypes[TreeType],"X")
		end
	end
end

function toggleTreeAmountClicked()
	if MakeBeach == true then
		if MakeBeachTrees == true then
			TreeAmount = TreeAmount + 25
			if TreeAmount > 100 then TreeAmount = 25 end
			this.SetInterfaceCaption("toggleTreeAmount", "tooltip_Button_TreeAmount",TreeAmount,"X")
		end
	end
end

function toggleTreeTypeClicked()
	if MakeBeach == true then
		if MakeBeachTrees == true then
			TreeType = TreeType + 1
			if TreeType > #TreeTypes then TreeType = 1 end
			this.SetInterfaceCaption("toggleTreeType", "tooltip_Button_TreeType",TreeTypes[TreeType],"X")
		end
	end
end

function toggleCreateBridgesClicked()
	if MakeBridges == true then
		MakeBridges = false
		NextPillar = 0
		ShowBridgeExample()
		this.SetInterfaceCaption("toggleCreateBridges", "tooltip_Button_CreateBridgesOff")
		this.SetInterfaceCaption("toggleCreateBridgePillars", "tooltip_Button_CreateBridgePillars0")
	else
		MakeBridges = true
		ShowBridgeExample()
		this.SetInterfaceCaption("toggleCreateBridges", "tooltip_Button_CreateBridgesOn")
		this.SetInterfaceCaption("toggleCreateBridgePillars", "tooltip_Button_CreateBridgePillars",NextPillar,"X")
	end
end

function toggleCreateBridgePillarsClicked()
	if MakeBridges == true then
		NextPillar = NextPillar + 2
		if NextPillar > 20 then
			NextPillar = 0
			this.SetInterfaceCaption("toggleCreateBridgePillars", "tooltip_Button_CreateBridgePillars0")
		else
			this.SetInterfaceCaption("toggleCreateBridgePillars", "tooltip_Button_CreateBridgePillars",NextPillar,"X")
		end
	end
end

function toggleCreateBridgesPathClicked()
	if SideWalk == "L" then			SideWalk = "R"
	elseif SideWalk == "R" then		SideWalk = "LR"
	elseif SideWalk == "LR" then	SideWalk = "N"
	elseif SideWalk == "N" then		SideWalk = "L"
	end
	ShowBridgeExample()
	this.SetInterfaceCaption("toggleCreateBridgesPath", "tooltip_Button_CreateSideWalk"..SideWalk)
end

function toggleCreateRoadBarriersClicked()
	if RoadBarriers == true then
		RoadBarriers = false
		this.SetInterfaceCaption("toggleCreateRoadBarriers", "tooltip_Button_CreateRoadBarriersOff")
	else
		RoadBarriers = true
		this.SetInterfaceCaption("toggleCreateRoadBarriers", "tooltip_Button_CreateRoadBarriersOn")
		if MakeBridges == nil then NextPillar = 0 end
	end
end

function toggleGateTypeClicked()
	if GateType == "RoadBarrier" then
		GateType = "RoadGate"
	else
		GateType = "RoadBarrier"
	end
	this.SetInterfaceCaption("toggleGateType", "tooltip_Button_GateType"..GateType)
end

function toggleWaterWalkableClicked()
	if CoastWalkable == 1 then
		CoastWalkable = 0
		if CoastShallow == 0 and CoastDeep == 1 then toggleWaterDeepClicked() end
	else
		CoastWalkable = 1
	end
	this.SetInterfaceCaption("toggleWaterWalkable", "tooltip_Button_CoastLineWalkable","tooltip_Button_CoastLine"..CoastWalkable,"X")
end

function toggleWaterShallowClicked()
	if CoastShallow == 1 then
		CoastShallow = 0
		if CoastWalkable == 0 and CoastDeep == 1 then toggleWaterDeepClicked() end
	else
		CoastShallow = 1
	end
	this.SetInterfaceCaption("toggleWaterShallow", "tooltip_Button_CoastLineShallow","tooltip_Button_CoastLine"..CoastShallow,"X")
end

function toggleWaterDeepClicked()
	if CoastDeep == 1 then
		CoastDeep = 0
	else
		CoastDeep = 1
	end
	this.SetInterfaceCaption("toggleWaterDeep", "tooltip_Button_CoastLineDeep","tooltip_Button_CoastLine"..CoastDeep,"X")
end

function BackupBridgeTiles()
	local x = World.OriginW+World.OriginX-17
	local y = -1
	
	for X = 1,15 do
		for Y = 1,4 do
			local cell = World.GetCell(x+X,y+Y)
			BridgeTilesBackup[Y][X] = cell.Mat
		end
	end
end

function RestoreBridgeTiles()
	local x = World.OriginW+World.OriginX-17
	local y = -1
	
	for X = 1,15 do
		for Y = 1,4 do
			local cell = World.GetCell(x+X,y+Y)
			cell.Mat = BridgeTilesBackup[Y][X]
		end
	end
end

function ShowBridgeExample()
	RestoreBridgeTiles()
	local BridgeLR = {
			{ 0, 1, 2, 2, 3, 4, 5, 7, 5, 6, 3, 2, 2, 1, 0 },
			{ 1, 1, 2, 2, 3, 4, 5, 5, 5, 6, 3, 2, 2, 1, 1 },
			{ 1, 1, 2, 2, 3, 4, 5, 7, 5, 6, 3, 2, 2, 1, 1 },
			{ 0, 1, 2, 2, 3, 4, 5, 5, 5, 6, 3, 2, 2, 1, 0 }
		}
		
	local BridgeL = {
			{ 0, 1, 2, 2, 3, 4, 5, 7, 5, 6, 3, 1, 0, 0, 0 },
			{ 1, 1, 2, 2, 3, 4, 5, 5, 5, 6, 3, 1, 1, 0, 0 },
			{ 1, 1, 2, 2, 3, 4, 5, 7, 5, 6, 3, 1, 1, 0, 0 },
			{ 0, 1, 2, 2, 3, 4, 5, 5, 5, 6, 3, 1, 0, 0, 0 }
		}
		
	local BridgeR = {
			{ 0, 0, 0, 1, 3, 4, 5, 7, 5, 6, 3, 2, 2, 1, 0 },
			{ 0, 0, 1, 1, 3, 4, 5, 5, 5, 6, 3, 2, 2, 1, 1 },
			{ 0, 0, 1, 1, 3, 4, 5, 7, 5, 6, 3, 2, 2, 1, 1 },
			{ 0, 0, 0, 1, 3, 4, 5, 5, 5, 6, 3, 2, 2, 1, 0 }
		}
		
	local Bridge = {
			{ 0, 0, 0, 1, 3, 4, 5, 7, 5, 6, 3, 1, 0, 0, 0 },
			{ 0, 0, 1, 1, 3, 4, 5, 5, 5, 6, 3, 1, 1, 0, 0 },
			{ 0, 0, 1, 1, 3, 4, 5, 7, 5, 6, 3, 1, 1, 0, 0 },
			{ 0, 0, 0, 1, 3, 4, 5, 5, 5, 6, 3, 1, 0, 0, 0 }
		}
		
	local NoBridgeLR = {
			{ 0, 0, 2, 2, 3, 4, 5, 7, 5, 6, 3, 2, 2, 0, 0 },
			{ 0, 0, 2, 2, 3, 4, 5, 5, 5, 6, 3, 2, 2, 0, 0 },
			{ 0, 0, 2, 2, 3, 4, 5, 7, 5, 6, 3, 2, 2, 0, 0 },
			{ 0, 0, 2, 2, 3, 4, 5, 5, 5, 6, 3, 2, 2, 0, 0 }
		}
		
	local NoBridgeL = {
			{ 0, 0, 2, 2, 3, 4, 5, 7, 5, 6, 3, 0, 0, 0, 0 },
			{ 0, 0, 2, 2, 3, 4, 5, 5, 5, 6, 3, 0, 0, 0, 0 },
			{ 0, 0, 2, 2, 3, 4, 5, 7, 5, 6, 3, 0, 0, 0, 0 },
			{ 0, 0, 2, 2, 3, 4, 5, 5, 5, 6, 3, 0, 0, 0, 0 }
		}
		
	local NoBridgeR = {
			{ 0, 0, 0, 0, 3, 4, 5, 7, 5, 6, 3, 2, 2, 0, 0 },
			{ 0, 0, 0, 0, 3, 4, 5, 5, 5, 6, 3, 2, 2, 0, 0 },
			{ 0, 0, 0, 0, 3, 4, 5, 7, 5, 6, 3, 2, 2, 0, 0 },
			{ 0, 0, 0, 0, 3, 4, 5, 5, 5, 6, 3, 2, 2, 0, 0 }
		}
		
	local NoBridge = {
			{ 0, 0, 0, 0, 3, 4, 5, 7, 5, 6, 3, 0, 0, 0, 0 },
			{ 0, 0, 0, 0, 3, 4, 5, 5, 5, 6, 3, 0, 0, 0, 0 },
			{ 0, 0, 0, 0, 3, 4, 5, 7, 5, 6, 3, 0, 0, 0, 0 },
			{ 0, 0, 0, 0, 3, 4, 5, 5, 5, 6, 3, 0, 0, 0, 0 }
		}
		
	local Tiles = {
			[0] = "Dirt", -- excluded from changing
			[1] = "ConcreteWall",
			[2] = "PavingStone",
			[3] = "ConcreteTiles",
			[4] = "RoadMarkingsLeft",
			[5] = "Road",
			[6] = "RoadMarkingsRight",
			[7] = "RoadMarkings"
		}
	
	local MyBridge = {}
	if MakeBridges == true then
		if SideWalk == "L" then MyBridge = BridgeL
		elseif SideWalk == "R" then MyBridge = BridgeR
		elseif SideWalk == "LR" then MyBridge = BridgeLR
		elseif SideWalk == "N" then MyBridge = Bridge end
	else
		if SideWalk == "L" then MyBridge = NoBridgeL
		elseif SideWalk == "R" then MyBridge = NoBridgeR
		elseif SideWalk == "LR" then MyBridge = NoBridgeLR
		elseif SideWalk == "N" then MyBridge = NoBridge end
	end
	local x = World.OriginW+World.OriginX-17
	local y = -1
	
	for X = 1,15 do
		for Y = 1,4 do
			if MyBridge[Y][X] > 0 then
				local cell = World.GetCell(x+X,y+Y)
				cell.Mat = Tiles[MyBridge[Y][X]]
			end
		end
	end
	MyBridge = nil
end

function IsWall(C)
	if string.find(C,"Wall") ~= nil or string.find(C,"Fence") ~= nil then
		return true
	else
		return false
	end
end

function IsPath(C)
	if string.find(C,"PavingStone") ~= nil or string.find(C,"ConcreteTiles") ~= nil then
		return true
	else
		return false
	end
end

function MakeBridge()
	local MyBridge = {}
	local BridgePos = endX-6
	
	if RoadBarriers == true then
		if NextPillar > 0 and endY == NextPillar + 1 then
			local newGate = Object.Spawn(GateType,endX+2.5,endY+0.5)
			newGate = nil
		elseif NextPillar > 0 and math.mod(endY,NextPillar) == 1 and endY > 1 then
			-- print("Pos.y: "..endY.." -> "..(World.NumCellsY-endY-NextPillar))
			if World.NumCellsY-endY-NextPillar <= 1 then
				local newGate = Object.Spawn(GateType,endX+2.5,endY+0.5)
				newGate = nil
				RoadBarriers = nil
			end
		elseif NextPillar == 0 and endY == 3 then
			local newGate = Object.Spawn(GateType,endX+2.5,endY+0.5)
			newGate = nil
		elseif NextPillar == 0 and World.NumCellsY-endY-2 <= 1 then
			local newGate = Object.Spawn(GateType,endX+2.5,endY+0.5)
			newGate = nil
			RoadBarriers = nil
		end
	end
	
	if MakeBridges == true then
		if NextPillar > 0 and math.mod(endY,NextPillar) <= 1 then	-- toggle a bridge pillar every now and then
			if SideWalk == "L" then MyBridge = BridgePillarL
			elseif SideWalk == "R" then MyBridge = BridgePillarR
			elseif SideWalk == "LR" then MyBridge = BridgePillarLR
			elseif SideWalk == "N" then MyBridge = BridgePillar end
		else
			if SideWalk == "L" then MyBridge = BridgeL
			elseif SideWalk == "R" then MyBridge = BridgeR
			elseif SideWalk == "LR" then MyBridge = BridgeLR
			elseif SideWalk == "N" then MyBridge = Bridge end
		end
	else
		if SideWalk == "L" then MyBridge = NoBridgeL
		elseif SideWalk == "R" then MyBridge = NoBridgeR
		elseif SideWalk == "LR" then MyBridge = NoBridgeLR
		elseif SideWalk == "N" then MyBridge = NoBridge end
	end
	
	if R == 1 then R = 2 else R = 1 end	-- toggle RoadMarkings on every other tile
	for X = 1,17 do
		if MyBridge[R][X] > 0 then  -- tile not excluded from changing
			DepthTable[endY][BridgePos] = 1
		end
		
		local cell = World.GetCell(BridgePos,endY)
		if BackupTable[endY][BridgePos] == nil then
			BackupTable[endY][BridgePos] = {}
			BackupTable[endY][BridgePos].Mat = cell.Mat
			BackupTable[endY][BridgePos].Ind = cell.Ind
			-- print("MakeBridge --> BackupTable["..endY.."]["..BridgePos.."].Mat -> "..BackupTable[endY][BridgePos].Mat)
		end
		
		if not cell.Ind and not IsWall(cell.Mat) then
			if cell.Room.i == -1 then
				if endY == 0 or endY == World.NumCellsY-1 then
					if MyBridge[R][X] >= 2 and MyBridge[R][X] <= 7 then -- draw road only
						cell.Mat,cell.Con = BridgeTiles[MyBridge[R][X]],100
						-- endX = BridgePos
					else
						cell.Mat,cell.Con = EdgeTile,100
						if not Is2018Edition then
							cell.Dep = 0
						end 
					end
						endX = BridgePos
				elseif MyBridge[R][X] > 0 then -- tile not excluded from changing
					cell.Mat,cell.Con = BridgeTiles[MyBridge[R][X]],100
					endX = BridgePos
					if MyBridge[R][X] == 8 then	-- make water tile brighter
						if not Is2018Edition then
							cell.Dep = 0
						end
					end
				end
			else
				if MyBridge[R][X] > 2 and MyBridge[R][X] < 8 then -- no PavingStone, Wall, Water tile
					cell.Mat,cell.Con = BridgeTiles[MyBridge[R][X]],100
					endX = BridgePos
				elseif X > 1 then
					if not Is2018Edition then
						cell.Mat,cell.Con = "NewCargoFloor",100
					else
						cell.Mat,cell.Con = "CeramicFloor",100
					end
				end
			end
		end
		cell = nil
		BridgePos = BridgePos + 1
	end
	MyBridge = nil
	BridgePos = nil
end


			-- DepthTable[y][x] = 0 -- Not filled yet
			-- DepthTable[y][x] = 1 -- Road/Bridge/MapEdge
			-- DepthTable[y][x] = 2 -- Island
			-- DepthTable[y][x] = 3 -- Water
			-- DepthTable[y][x] = 4 -- Beach
function MakeWaterMap()
	for y = endY,EdgeBottom+1 do
		for x = endX,EdgeRight+1 do
			table.insert(DepthTable[endY],endX)
			local cell = World.GetCell(endX,endY)
			if BackupTable[endY][endX] == nil then
				BackupTable[endY][endX] = {}
				BackupTable[endY][endX].Mat = cell.Mat
				BackupTable[endY][endX].Ind = cell.Ind
				-- print("BackupTable["..endY.."]["..endX.."].Mat -> "..BackupTable[endY][endX].Mat)
			end
			if cell.Mat == "RoadMarkingsLeft" then
				MakeBridge()
			else
				if endX == 0 or endX == EdgeRight+1 or endY == 0 or endY == EdgeBottom+1 then	-- create map edge
					cell.Mat,cell.Con = EdgeTile,100		-- will be walkable BorderWater in 2018 edition
					if not Is2018Edition then
						cell.Dep = 0.05
					end
					DepthTable[endY][endX] = 1
				elseif endX == 1 or endX == EdgeRight or endY == 1 or endY == EdgeBottom then	-- create inner water edge to prevent islands being drawn all the way to the map edge
					cell.Mat,cell.Con = "Water",100
					if not Is2018Edition then
						cell.Dep = 0.05
					end
					DepthTable[endY][endX] = 1
				elseif cell.Ind == true then	-- "Island Plotter" room or another room type detected
					cell.Con = 0
					DepthTable[endY][endX] = 2
				elseif IsPath(cell.Mat) then		-- PavingStone or ConcreteTiles area detected
					cell.Con = 0
					if not Is2018Edition then
						cell.Dep = 0.00007 * math.random(1,10)
					end
					DepthTable[endY][endX] = 2
				elseif cell.Room.i > -1 then	-- island area detected
					cell.Con = 0
					if not Is2018Edition then
						cell.Dep = 0.00007 * math.random(1,10)
					end
					if IslandType > 0 then		-- when custom island tiles were specified
						cell.Mat = IslandTypes[IslandType]
					end
					DepthTable[endY][endX] = 2
				elseif cell.Room.i == -1 and not cell.Ind and not IsWall(cell.Mat) then	-- water area detected
					cell.Mat,cell.Con = "Water",100
					if not Is2018Edition then
						cell.Dep = 0.05
					end
					DepthTable[endY][endX] = 3
				end
			end
			cell = nil
			endX = endX + 1
			
			if endX > EdgeRight+1 then
				endX = 0
				endY = endY + 1
				if endY > EdgeBottom+1 then
					if MakeBeach == true then
						endX = 2
						endY = 2
						Set(this,"Pos.x",2)
						Set(this,"Pos.y",2)
						MakeBridges = false
						CreateWaterMap = false
						this.SetInterfaceCaption("Caption_PlottingRound", "tooltip_Caption_PlottingBeach",BeachRound,"X")
						CreateBeachMap = true
					else
						PreparePlotButtons()
					end
					return
				else
					this.Pos.y = endY
					
					table.insert(BackupTable,endY)
					BackupTable[endY] = {}
					
					table.insert(DepthTable,endY)
					DepthTable[endY] = {}
					table.insert(DepthTable[endY],0)
				end
			end
			
			TotTick = TotTick + 1
			if TotTick >= PerTick then
				TotTick = 0
				this.Pos.x = endX
				Progress = Progress + 1
				if Progress > 8 then Progress = 0 end
				this.SetInterfaceCaption("Caption_WaterInProgress", "tooltip_Caption_WaterInProgress"..Progress)
				return
			end
		end
		break
	end
end

function PlotBeach()
	for y = endY,EdgeBottom do
		for x = endX,EdgeRight do
			if BeachRound > 3 then	-- round 4&5 smoothens the beach by filling up most of the water puddles which may have emerged
				if DepthTable[endY][endX] == 3 then
					FillSurroundedWater(endX,endY)
				end
			else	-- plot 3 random strokes of beach tiles around the island
				if DepthTable[endY][endX] == 2 and IsIslandEdgeTile(endX,endY) then
					if math.random(1,BeachRound) == BeachRound then
						if math.random() > 0.5 then
							ChangeToBeachTile(endX-math.random(1,2),endY+math.random(-1,1),"Left")
							ChangeToBeachTile(endX+math.random(1,2),endY+math.random(-1,1),"Right")
						else
							ChangeToBeachTile(endX+math.random(-1,1),endY-math.random(1,2),"Top")
							ChangeToBeachTile(endX+math.random(-1,1),endY+math.random(1,2),"Bottom")
						end
					end
				end
			end
			endX = endX + 1
			
			if endX > EdgeRight then
				endX = 2
				endY = endY + 1
				this.Pos.x = 2
				if endY > EdgeBottom then
					for yY = 0,World.NumCellsY-1 do
						for xX = 0,World.NumCellsX-1 do									-- marks just updated beach strokes as island 'room'
							if DepthTable[yY][xX] == 4 then DepthTable[yY][xX] = 2 end	-- so the new border around the island is expanded
						end
					end
					BeachRound = BeachRound + 1
					this.SetInterfaceCaption("Caption_PlottingRound", "tooltip_Caption_PlottingBeach",BeachRound,"X")
					if BeachRound <= 5 then
						endX = 2
						endY = 2
						Set(this,"Pos.x",2)
						Set(this,"Pos.y",2)
					else
						CreateBeachMap = false
						PreparePlotButtons()
					end
				else
					this.Pos.y = endY
				end
			end
			
			TotTick = TotTick + 1
			if TotTick >= PerTick then
				TotTick = 0
				-- this.Pos.x = endX
				Progress = Progress + 1
				if Progress > 8 then Progress = 0 end
				this.SetInterfaceCaption("Caption_WaterInProgress", "tooltip_Caption_WaterInProgress"..Progress)
				timeTot = timePerUpdate
				return
			end
		end
		timeTot = timePerUpdate
		break
	end
end

function FillSurroundedWater(X,Y)
	if (DepthTable[Y][X-1] == 2 and DepthTable[Y][X+1] == 2) or (DepthTable[Y-1][X] == 2 and DepthTable[Y+1][X] == 2) then
		this.Pos.x = X
		this.Pos.y = Y
		local SurroundedWaterTile = World.GetCell(X,Y)
		if not SurroundedWaterTile.Ind and not IsWall(SurroundedWaterTile.Mat) and not IsPath(SurroundedWaterTile.Mat) then
			SurroundedWaterTile.Mat = BeachTiles[BeachType]
			SurroundedWaterTile.Con = 0
			if not Is2018Edition then
				SurroundedWaterTile.Dep = 0.00007 * math.random(1,10)
			end
			DepthTable[Y][X] = 2
			SurroundedWaterTile = nil
			if MakeBeachTrees == true and math.random(1,100) <= TreeAmount then
				CreateBeachTree(X,Y)
			end
		end
	end
end

function IsIslandEdgeTile(X,Y)
	local y = -1
	for i = 1,3 do
		local x = -1
		for j = 1,3 do
			if i~= 2 and j ~= 2 then
				if DepthTable[Y+y][X+x] == 3 then
					local BeachEdge = World.GetCell(X,Y)
					if not BeachEdge.Ind and not IsWall(BeachEdge.Mat) and not IsPath(BeachEdge.Mat) then
						this.Pos.x = X
						this.Pos.y = Y
						if math.random() > 0.80 then
							if AvailableCoastTiles > 1 then
								BeachEdge.Mat = CoastTiles[math.random(2,AvailableCoastTiles)]
							else
								BeachEdge.Mat = BeachTiles[BeachType]
							end
						else
							BeachEdge.Mat = BeachTiles[BeachType]
						end
						BeachEdge.Con = 0
						if not Is2018Edition then
							BeachEdge.Dep = 0.00007 * math.random(1,10)
						end
						DepthTable[Y][X] = 4
						BeachEdge = nil
						return true
					end
					BeachEdge = nil
				end
			end
			x = x + 1
		end
		y = y + 1
	end
	return false
end

function ChangeToBeachTile(X,Y,Direction)
	local UpdateCell = false
	if Direction == "Left"		 and DepthTable[Y][X] >= 3 then UpdateCell = true
	elseif Direction == "Right"	 and DepthTable[Y][X] >= 3 then UpdateCell = true
	elseif Direction == "Top"	 and DepthTable[Y][X] >= 3 then UpdateCell = true
	elseif Direction == "Bottom" and DepthTable[Y][X] >= 3 then UpdateCell = true
	end
	if UpdateCell == true then
		local BeachTile = World.GetCell(X,Y)
		if not BeachTile.Ind and not IsWall(BeachTile.Mat) and not IsPath(BeachTile.Mat) then
			this.Pos.x = X
			this.Pos.y = Y
			BeachTile.Mat = BeachTiles[BeachType]
			BeachTile.Con = 0
			if not Is2018Edition then
				BeachTile.Dep = 0.00007 * math.random(1,10)
			end
			DepthTable[Y][X] = 4
		end
		BeachTile = nil
		UpdateCell = nil
	end
end

function PreparePlotButtons()
	Interface.RemoveComponent(this,"Caption_PlottingRound")
	Interface.RemoveComponent(this,"Caption_WaterPleaseWait")
	Interface.RemoveComponent(this,"Caption_WaterInProgress")
	Interface.AddComponent(this,"Caption_RestartPlotting", "Caption", "tooltip_Caption_RestartPlotting")
	Interface.AddComponent(this,"RestartPlotting", "Button", "tooltip_Button_RestartPlotting")
	Interface.AddComponent(this,"Caption_CoastLine", "Caption", "tooltip_Caption_CoastLine")
	Interface.AddComponent(this,"toggleCoastDirt", "Button", "tooltip_Button_CoastLineDirt","tooltip_Button_CoastLine"..CoastDirt,"X")
	Interface.AddComponent(this,"toggleCoastLooseStone", "Button", "tooltip_Button_CoastLineLooseStone","tooltip_Button_CoastLine"..CoastStone,"X")
	Interface.AddComponent(this,"toggleCoastSand", "Button", "tooltip_Button_CoastLineSand","tooltip_Button_CoastLine"..CoastSand,"X")
	Interface.AddComponent(this,"toggleCoastGrass", "Button", "tooltip_Button_CoastLineGrass","tooltip_Button_CoastLine"..CoastGrass,"X")
	if MakeCoastLine == true then
		Interface.AddComponent(this,"toggleCoastBeach", "Button", "tooltip_Button_CoastLineBeach","tooltip_Button_CoastLine"..CoastBeach,"X")
	end
	if IslandType > 0 then
		Interface.AddComponent(this,"toggleCoastCustom", "Button", "tooltip_Button_CoastLineCustom","tooltip_Button_CoastLine"..CoastCustom,"X")
	end
	Interface.AddComponent(this,"Caption_IslandDivider2", "Caption", "tooltip_Button_DepthAmount15")
	if MakeReef == true then
		Interface.AddComponent(this,"toggleReef", "Button", "tooltip_Button_CoastLineReefOn")
	else
		Interface.AddComponent(this,"toggleReef", "Button", "tooltip_Button_CoastLineReefOff")
	end
	Interface.AddComponent(this,"Caption_CoastPlotter", "Caption", "tooltip_Caption_IslandPlotter")
	Interface.AddComponent(this,"PlotWaterWalkable", "Button", "tooltip_Button_PlotWaterWalkable")
	Interface.AddComponent(this,"PlotWaterShallow", "Button", "tooltip_Button_PlotWaterShallow")
	if not Is2018Edition then
		Interface.AddComponent(this,"PlotWaterDepth", "Button", "tooltip_Button_PlotWaterDepth",Multiplier,"X")
	end
	Interface.AddComponent(this,"Caption_IslandDivider3", "Caption", "tooltip_Button_DepthAmount15")
	Interface.AddComponent(this,"Caption_SaveReload", "Caption", "tooltip_Caption_SaveReload")
	Interface.AddComponent(this,"Caption_ForCleanFloor", "Caption", "tooltip_Caption_ForCleanFloor")
	Interface.AddComponent(this,"Caption_IslandDivider4", "Caption", "tooltip_Button_DepthAmount15")
	Interface.AddComponent(this,"toggleRemoveAllTrees", "Button", "tooltip_Button_RemoveAllTrees")
	if World.CheatsEnabled == true then
		Interface.AddComponent(this,"toggleCheats", "Button", "tooltip_Button_ToggleCheatsOn")
	else
		Interface.AddComponent(this,"toggleCheats", "Button", "tooltip_Button_ToggleCheatsOff")
	end
	Interface.AddComponent(this,"Caption_ToggleCheats1", "Caption", "tooltip_Caption_ToggleCheats1")
	Interface.AddComponent(this,"Caption_ToggleCheats2", "Caption", "tooltip_Caption_ToggleCheats2")
	Interface.AddComponent(this,"Caption_ToggleCheats3", "Caption", "tooltip_Caption_ToggleCheats3")
	Interface.AddComponent(this,"Caption_ToggleCheats4", "Caption", "tooltip_Caption_ToggleCheats4")
	Set(this,"Tooltip","tooltip_IslandPlotterB")
	local cell = World.GetCell(0,0)
	cell.Mat = EdgeTile
	cell = nil
	local cell = World.GetCell(EdgeRight+1,EdgeBottom+1)
	cell.Mat = "Road"
	cell = nil
	Set(this,"Pos.x",2)
	Set(this,"Pos.y",2)
	MakeBridges = false
	CreateWaterMap = false
	if AutoPlotting == true then
		if CoastWalkable == 1 then
			PlotWaterWalkableClicked()
		elseif CoastShallow == 1 then
			PlotWaterShallowClicked()
		elseif CoastDeep == 1 then
			PlotWaterDepthClicked()
		end
	end
end

function toggleCoastDirtClicked()	-- toggles if a coast line should contain some Dirt tiles
	if CoastDirt == 1 then
		CoastDirt = 0
	else
		CoastDirt = 1
	end
	this.SetInterfaceCaption("toggleCoastDirt", "tooltip_Button_CoastLineDirt","tooltip_Button_CoastLine"..CoastDirt,"X")
end

function toggleCoastLooseStoneClicked()	-- toggles if a coast line should contain some Loose Stone tiles
	if CoastStone == 1 then
		CoastStone = 0
	else
		CoastStone = 1
	end
	this.SetInterfaceCaption("toggleCoastLooseStone", "tooltip_Button_CoastLineLooseStone","tooltip_Button_CoastLine"..CoastStone,"X")
end

function toggleCoastSandClicked()	-- toggles if a coast line should contain some Sand tiles
	if CoastSand == 1 then
		CoastSand = 0
	else
		CoastSand = 1
	end
	this.SetInterfaceCaption("toggleCoastSand", "tooltip_Button_CoastLineSand","tooltip_Button_CoastLine"..CoastSand,"X")
end

function toggleCoastGrassClicked()	-- toggles if a coast line should contain some Long Grass tiles
	if CoastGrass == 1 then
		CoastGrass = 0
	else
		CoastGrass = 1
	end
	this.SetInterfaceCaption("toggleCoastGrass", "tooltip_Button_CoastLineGrass","tooltip_Button_CoastLine"..CoastGrass,"X")
end

function toggleCoastBeachClicked()	-- toggles if a coast line should contain some specific IslandTypes tiles
	if CoastBeach == 1 then
		CoastBeach = 0
	else
		CoastBeach = 1
	end
	this.SetInterfaceCaption("toggleCoastBeach", "tooltip_Button_CoastLineBeach","tooltip_Button_CoastLine"..CoastBeach,"X")
end

function toggleCoastCustomClicked()	-- toggles if a coast line should contain some specific IslandTypes tiles
	if CoastCustom == 1 then
		CoastCustom = 0
	else
		CoastCustom = 1
	end
	this.SetInterfaceCaption("toggleCoastCustom", "tooltip_Button_CoastLineCustom","tooltip_Button_CoastLine"..CoastCustom,"X")
end

function toggleReefClicked()
	if MakeReef == true then
		MakeReef = false
		this.SetInterfaceCaption("toggleReef", "tooltip_Button_CoastLineReefOff")
	else
		MakeReef = true
		this.SetInterfaceCaption("toggleReef", "tooltip_Button_CoastLineReefOn")
	end
end

function PlotWaterWalkableClicked()
	Round = 1
	InitWaterPlotting()
end

function PlotWaterShallowClicked()
	if Round < 2 then
		Round = 2
	end
	InitWaterPlotting()
end

function PlotWaterDepthClicked()
	if Round < 3 then
		Round = 3
	end
	InitWaterPlotting()
end

function RestartPlottingClicked()
	Interface.RemoveComponent(this,"Caption_RestartPlotting")
	Interface.RemoveComponent(this,"RestartPlotting")
	Interface.RemoveComponent(this,"Caption_CoastLine")
	Interface.RemoveComponent(this,"toggleCoastDirt")
	Interface.RemoveComponent(this,"toggleCoastLooseStone")
	Interface.RemoveComponent(this,"toggleCoastSand")
	Interface.RemoveComponent(this,"toggleCoastGrass")
	Interface.RemoveComponent(this,"toggleCoastBeach")
	Interface.RemoveComponent(this,"toggleCoastCustom")
	Interface.RemoveComponent(this,"Caption_IslandDivider2")
	Interface.RemoveComponent(this,"toggleReef")
	Interface.RemoveComponent(this,"Caption_CoastPlotter")
	Interface.RemoveComponent(this,"PlotWaterWalkable")
	Interface.RemoveComponent(this,"PlotWaterShallow")
	Interface.RemoveComponent(this,"PlotWaterDepth")
	Interface.RemoveComponent(this,"Caption_IslandDivider3")
	Interface.RemoveComponent(this,"Caption_SaveReload")
	Interface.RemoveComponent(this,"Caption_ForCleanFloor")
	Interface.RemoveComponent(this,"Caption_IslandDivider4")
	Interface.RemoveComponent(this,"toggleRemoveAllTrees")
	Interface.RemoveComponent(this,"toggleCheats")
	Interface.RemoveComponent(this,"Caption_ToggleCheats1")
	Interface.RemoveComponent(this,"Caption_ToggleCheats2")
	Interface.RemoveComponent(this,"Caption_ToggleCheats3")
	Interface.RemoveComponent(this,"Caption_ToggleCheats4")
	Interface.AddComponent(this,"Caption_CleanUp", "Caption", "tooltip_Caption_CleanUpPlotting")
	Interface.AddComponent(this,"Caption_WaterPleaseWait", "Caption", "tooltip_Caption_WaterPleaseWait")
	Interface.AddComponent(this,"Caption_WaterInProgress", "Caption", "tooltip_Caption_WaterInProgress"..Progress)
	RemoveRoadGates()
	RemoveTrees(this,10000,true)
	DepthTable = nil
	DepthTable = {}
	endX = 0
	endY = 0
	Set(this,"Pos.x",0)
	Set(this,"Pos.y",0)
	UndoPlotting = true
end

function RestartPlotting()
	for y = endY,EdgeBottom+1 do
		for x = endX,EdgeRight+1 do
			local cell = World.GetCell(endX,endY)
			if BackupTable[endY][endX] ~= nil then
				cell.Mat = BackupTable[endY][endX].Mat
				cell.Ind = BackupTable[endY][endX].Ind
				-- print("Restore --> BackupTable["..endY.."]["..endX.."].Mat -> "..BackupTable[endY][endX].Mat)
				if not Is2018Edition then
					cell.Dep = 0
				end
			end
			cell = nil
			endX = endX + 1
			
			if endX > EdgeRight+1 then
				endX = 0
				endY = endY + 1
				if endY > EdgeBottom+1 then
					Interface.RemoveComponent(this,"Caption_CleanUp")
					Interface.RemoveComponent(this,"Caption_WaterPleaseWait")
					Interface.RemoveComponent(this,"Caption_WaterInProgress")
					endX = 0
					endY = 0
					Set(this,"Pos.x",0)
					Set(this,"Pos.y",0)
					BackupTable = nil
					BackupTable = {}
					Round = 1
					BeachRound = 1
					Multiplier = 1
					MakeCoastLine = true
					CoastLineMade = false
					CoastDirt = 0
					CoastSand = 0
					CoastStone = 0
					CoastGrass = 0
					CoastBeach = 0
					CoastCustom = 0
					CoastWalkable = 1
					CoastShallow = 1
					CoastDeep = 1
					IslandType = 0
					MakeBeachTrees = true
					TreeType = 5
					TreeAmount = 25
					MakeBeach = true
					BeachType = 0
					RoadBarriers = false
					GateType = "RoadBarrier"
					MakeBridges = false
					NextPillar = 8
					MakeReef = false
					CreateWaterMap = false
					CreateBeachMap = false
					PlotWaterDepth = false
					UndoPlotting = false
					AutoPlotting = false
					SideWalk = "L"
					InitButtons()
					return
				else
					this.Pos.y = endY
				end
			end
			
			TotTick = TotTick + 1
			if TotTick >= PerTick then
				TotTick = 0
				this.Pos.x = endX
				Progress = Progress + 1
				if Progress > 8 then Progress = 0 end
				this.SetInterfaceCaption("Caption_WaterInProgress", "tooltip_Caption_WaterInProgress"..Progress)
				return
			end
		end
		break
	end
end

function InitWaterPlotting()
	endX = 2
	endY = 2
	Set(this,"Pos.x",2)
	Set(this,"Pos.y",2)
	EdgeTile = "Water"
	PerTick = 10
	TotTick = 0
	Progress = 0
	for yY = 0,World.NumCellsY-1 do
		for xX = 0,World.NumCellsX-1 do	-- from now on the Beach = 4, Walkable = 5, Shallow = 6, Deep = 7-11
			if DepthTable[yY][xX] == 2 then DepthTable[yY][xX] = 4 end
		end
	end
	if Is2018Edition == true then
		EdgeTile = "BorderWater"
	end
	CoastTiles = {}
	if not Is2018Edition then
		if Round == 1		 then table.insert(CoastTiles,"WaterWalkable") end
		if Round == 2		 then table.insert(CoastTiles,"WaterShallow") end
		if Round == 3		 then table.insert(CoastTiles,"Water") end
	elseif Round == 1		 then table.insert(CoastTiles,"BorderWater")
	elseif Round == 2		 then table.insert(CoastTiles,"BorderWater")
	elseif Round == 3		 then table.insert(CoastTiles,"Water")
	end
	if CoastDirt == 1	 then table.insert(CoastTiles,"Dirt") end
	if CoastGrass == 1	 then table.insert(CoastTiles,"LongGrass") end
	if CoastSand == 1	 then table.insert(CoastTiles,"Sand") end
	if CoastStone == 1	 then table.insert(CoastTiles,"LooseStone")end
	if CoastBeach == 1	 then table.insert(CoastTiles,BeachTiles[BeachType]) end
	if CoastCustom == 1 and IslandType > 0 then table.insert(CoastTiles,IslandTypes[IslandType]) end
	AvailableCoastTiles = #CoastTiles
	Interface.RemoveComponent(this,"Caption_RestartPlotting")
	Interface.RemoveComponent(this,"RestartPlotting")
	Interface.RemoveComponent(this,"Caption_CoastLine")
	Interface.RemoveComponent(this,"toggleCoastDirt")
	Interface.RemoveComponent(this,"toggleCoastLooseStone")
	Interface.RemoveComponent(this,"toggleCoastSand")
	Interface.RemoveComponent(this,"toggleCoastGrass")
	Interface.RemoveComponent(this,"toggleCoastBeach")
	Interface.RemoveComponent(this,"toggleCoastCustom")
	Interface.RemoveComponent(this,"Caption_IslandDivider2")
	Interface.RemoveComponent(this,"toggleReef")
	Interface.RemoveComponent(this,"Caption_CoastPlotter")
	Interface.RemoveComponent(this,"PlotWaterWalkable")
	Interface.RemoveComponent(this,"PlotWaterShallow")
	Interface.RemoveComponent(this,"PlotWaterDepth")
	Interface.RemoveComponent(this,"Caption_IslandDivider3")
	Interface.RemoveComponent(this,"Caption_SaveReload")
	Interface.RemoveComponent(this,"Caption_ForCleanFloor")
	Interface.RemoveComponent(this,"Caption_IslandDivider4")
	Interface.RemoveComponent(this,"toggleRemoveAllTrees")
	Interface.RemoveComponent(this,"toggleCheats")
	Interface.RemoveComponent(this,"Caption_ToggleCheats1")
	Interface.RemoveComponent(this,"Caption_ToggleCheats2")
	Interface.RemoveComponent(this,"Caption_ToggleCheats3")
	Interface.RemoveComponent(this,"Caption_ToggleCheats4")
	Interface.AddComponent(this,"Caption_PlottingRound", "Caption", "tooltip_Caption_PlottingRound","tooltip_PlottingRound"..Round,"X")
	Interface.AddComponent(this,"Caption_WaterPleaseWait", "Caption", "tooltip_Caption_WaterPleaseWait")
	Interface.AddComponent(this,"Caption_WaterInProgress", "Caption", "tooltip_Caption_WaterInProgress"..Progress)
	PlotWaterDepth = true	-- triggers Update() to start plotting
end

function PlotDepth()
	for y = endY,EdgeBottom do
		for x = endX,EdgeRight do
			-- from now on the initial Water = 3, Beach = 4, Walkable = 5, Shallow = 6, Deep = 7-11
			-- print("y: "..endY.." x: "..endX.." -> "..DepthTable[endY][endX])
			
			if Round > 1 and DepthTable[endY-1][endX-1] > 2 then			-- adjust tile which is top left of the current tile first
				local cell = World.GetCell(endX-1,endY-1)					-- it does seem to improve the coast line depth a little bit
				if not cell.Ind and not IsWall(cell.Mat) then AdjustDepth(cell,endX-1,endY-1) end	-- but it's hard to tell since the beach is so random.
				cell = nil													-- seems to reduce NO ACCESS tiles a bit more,
			end																-- but can probably be commented out and nobody would notice...
			
			if DepthTable[endY][endX] > 2 then
				local cell = World.GetCell(endX,endY)
				if not cell.Ind and not IsWall(cell.Mat) then AdjustDepth(cell,endX,endY) end
				cell = nil
			end
			endX = endX + 1
			
			if endX > EdgeRight then
				endX = 2
				endY = endY + 1
				this.Pos.x = 2
				if endY > EdgeBottom then
					if CoastLineMade == true then
						MakeCoastLine = false
					end
					if Round > 2 then
						Multiplier = Multiplier + 1
					end
					Round = Round + 1
					Interface.RemoveComponent(this,"Caption_PlottingRound")
					Interface.RemoveComponent(this,"Caption_WaterPleaseWait")
					Interface.RemoveComponent(this,"Caption_WaterInProgress")
					Interface.AddComponent(this,"RestartPlotting", "Button", "tooltip_Button_RestartPlotting")
					if CoastLineMade == false then
						Interface.AddComponent(this,"Caption_CoastLine", "Caption", "tooltip_Caption_CoastLine")
						Interface.AddComponent(this,"toggleCoastDirt", "Button", "tooltip_Button_CoastLineDirt","tooltip_Button_CoastLine"..CoastDirt,"X")
						Interface.AddComponent(this,"toggleCoastLooseStone", "Button", "tooltip_Button_CoastLineLooseStone","tooltip_Button_CoastLine"..CoastStone,"X")
						Interface.AddComponent(this,"toggleCoastSand", "Button", "tooltip_Button_CoastLineSand","tooltip_Button_CoastLine"..CoastSand,"X")
						Interface.AddComponent(this,"toggleCoastGrass", "Button", "tooltip_Button_CoastLineGrass","tooltip_Button_CoastLine"..CoastGrass,"X")
						if MakeCoastLine == true then
							Interface.AddComponent(this,"toggleCoastBeach", "Button", "tooltip_Button_CoastLineBeach","tooltip_Button_CoastLine"..CoastBeach,"X")
						end
						if IslandType > 0 then
							Interface.AddComponent(this,"toggleCoastCustom", "Button", "tooltip_Button_CoastLineCustom","tooltip_Button_CoastLine"..CoastCustom,"X")
						end
						Interface.AddComponent(this,"Caption_IslandDivider2", "Caption", "tooltip_Button_DepthAmount15")
						if MakeReef == true then
							Interface.AddComponent(this,"toggleReef", "Button", "tooltip_Button_CoastLineReefOn")
						else
							Interface.AddComponent(this,"toggleReef", "Button", "tooltip_Button_CoastLineReefOff")
						end
					end
					if Round <= 7 and not Is2018Edition then Interface.AddComponent(this,"Caption_CoastPlotter", "Caption", "tooltip_Caption_IslandPlotter")
					elseif Round <= 2 and Is2018Edition == true then Interface.AddComponent(this,"Caption_CoastPlotter", "Caption", "tooltip_Caption_IslandPlotter") end
					if Round <= 1 then Interface.AddComponent(this,"PlotWaterWalkable", "Button", "tooltip_Button_PlotWaterWalkable") end
					if Round <= 2 then Interface.AddComponent(this,"PlotWaterShallow", "Button", "tooltip_Button_PlotWaterShallow") end
					if not Is2018Edition then
						if Round <= 7 then Interface.AddComponent(this,"PlotWaterDepth", "Button", "tooltip_Button_PlotWaterDepth",Multiplier,"X") 
							Interface.AddComponent(this,"Caption_IslandDivider3", "Caption", "tooltip_Button_DepthAmount15")
						end
					end
					Interface.AddComponent(this,"Caption_SaveReload", "Caption", "tooltip_Caption_SaveReload")
					Interface.AddComponent(this,"Caption_ForCleanFloor", "Caption", "tooltip_Caption_ForCleanFloor")
					Interface.AddComponent(this,"Caption_IslandDivider4", "Caption", "tooltip_Button_DepthAmount15")
					Interface.AddComponent(this,"toggleRemoveAllTrees", "Button", "tooltip_Button_RemoveAllTrees")
					if World.CheatsEnabled == true then
						Interface.AddComponent(this,"toggleCheats", "Button", "tooltip_Button_ToggleCheatsOn")
					else
						Interface.AddComponent(this,"toggleCheats", "Button", "tooltip_Button_ToggleCheatsOff")
					end
					Interface.AddComponent(this,"Caption_ToggleCheats1", "Caption", "tooltip_Caption_ToggleCheats1")
					Interface.AddComponent(this,"Caption_ToggleCheats2", "Caption", "tooltip_Caption_ToggleCheats2")
					Interface.AddComponent(this,"Caption_ToggleCheats3", "Caption", "tooltip_Caption_ToggleCheats3")
					Interface.AddComponent(this,"Caption_ToggleCheats4", "Caption", "tooltip_Caption_ToggleCheats4")
					local cell = World.GetCell(EdgeRight+1,EdgeBottom+1)
					cell.Mat = "Road"
					cell = nil
					Set(this,"Pos.x",2)
					Set(this,"Pos.y",2)
					MakeBridges = false
					PlotWaterDepth = false
					if AutoPlotting == true then
						if Round == 2 then
							if CoastShallow == 1 then PlotWaterShallowClicked() end
						elseif Round <= 7 and CoastDeep == 1 and not Is2018Edition then
							PlotWaterDepthClicked()
						end
					end
					return
				else
					this.Pos.y = endY
				end
			end
			
			TotTick = TotTick + 1
			if TotTick >= PerTick then
				TotTick = 0
				-- this.Pos.x = endX
				Progress = Progress + 1
				if Progress > 8 then Progress = 0 end
				this.SetInterfaceCaption("Caption_WaterInProgress", "tooltip_Caption_WaterInProgress"..Progress)
				timeTot = timePerUpdate
				return
			end
		end
		timeTot = timePerUpdate
		break
	end
end

function AdjustDepth(MyCell,X,Y)
	local PriorDepthCount = Round+2
	local CurDepthCount = Round+3 -- starts at 4 which is beach tiles
	local TilesAroundMe = { -- the centre tile is current active tile
			{ "Empty", "Empty", "Empty" },
			{ "Empty", "Empty", "Empty" },
			{ "Empty", "Empty", "Empty" }
		}
		-- from now on the initial Water = 3, Beach = 4, Walkable = 5, Shallow = 6, Deep = 7-11
	local y = -1
	for i = 1,3 do
		local x = -1
		for j = 1,3 do
			TilesAroundMe[i][j] = DepthTable[Y+y][X+x]
			x = x + 1
		end
		y = y + 1
	end
	TilesAroundMe[2][2] = "Empty"
	
	for i = 1,3 do
		for j = 1,3 do
			if TilesAroundMe[i][j] ~= "Empty" then
				-- print("TilesAroundMe[i][j] -> "..TilesAroundMe[i][j].." DepthTable["..Y.."]["..X.."] -> "..DepthTable[Y][X])
				if PriorDepthCount > 3 and TilesAroundMe[i][j] == PriorDepthCount and DepthTable[Y][X] == 3 then
					MyCell.Mat = WaterTiles[Round-1]
					DepthTable[Y][X] = CurDepthCount
					if Round == 1 then
						if not Is2018Edition then
							MyCell.Dep = -0.00007 * math.random(1,10)
						end
						MyCell.Con = 0
					elseif Round == 2 then
						if not Is2018Edition then
							MyCell.Dep = 0.0002 * math.random(1,4)
						end
						MyCell.Con = 0				
					elseif Round >= 3 then
						if not Is2018Edition then
							MyCell.Dep = 0.01 * math.random(Multiplier,Multiplier+1)
						end
						MyCell.Con = 0
					end
					this.Pos.x = X
					this.Pos.y = Y
					break
					
				elseif TilesAroundMe[i][j] == CurDepthCount and DepthTable[Y][X] == 3 then
					local RND = math.random()
					if RND >= 0.10 or not MakeCoastLine then
						MyCell.Mat = WaterTiles[Round]
						DepthTable[Y][X] = CurDepthCount+1
					else
						if AvailableCoastTiles > 1 and X > 6 and X < EdgeRight-6 and Y > 6 and Y < EdgeBottom-6 then
							MyCell.Mat = CoastTiles[math.random(2,AvailableCoastTiles)]
							DepthTable[Y][X] = CurDepthCount
						else
							MyCell.Mat = WaterTiles[Round]
							DepthTable[Y][X] = CurDepthCount+1
						end
						CoastLineMade = true
					end
					if RND < 0.33 and MakeReef == true and MakeCoastLine == true then
						if X > 6 and X < EdgeRight-6 and Y > 6 and Y < EdgeBottom-6 then -- makes sure a reef doesn't go all the way to map edge and leave some space to draw diferent water depths around it
							MyCell.Mat = ReefTiles[math.random(1,4)]
							DepthTable[Y][X] = CurDepthCount
						end
					end
					if Round == 1 then
						if not Is2018Edition then
							MyCell.Dep = -0.00007 * math.random(1,10)
						end
						MyCell.Con = 0
					elseif Round == 2 then
						if not Is2018Edition then
							MyCell.Dep = 0.0002 * math.random(1,4)
						end
						MyCell.Con = 0				
					elseif Round >= 3 then
						if not Is2018Edition then
							MyCell.Dep = 0.01 * math.random(Multiplier,Multiplier+1)
						end
						MyCell.Con = 0
					end
					this.Pos.x = X
					this.Pos.y = Y
					RND = nil
					break
				end
			end
		end
	end
	TilesAroundMe = nil
end

function CreateBeachTree(X,Y)
	if TreeType < 6 then
		if not Is2018Edition and math.random() > 0.9 then
			local newTree = Object.Spawn("Bush",X,Y)
		else
			local newTree = Object.Spawn("Tree",X,Y)
			newTree.SubType = TreeType
			newTree.Age = 7200
			newTree = nil
		end
	elseif not Is2018Edition and TreeType > 6 then
		local newTree = Object.Spawn(TreeTypes[TreeType],X,Y)
		newTree.Age = 7200
		newTree = nil
	else
		local newTree = Object.Spawn("Tree",X,Y)
		newTree.SubType = math.random(0,4)
		newTree.Age = 7200
		newTree = nil
	end
end

function toggleRemoveAllTreesClicked()
	Set(this,"Pos.x",EdgeRight/2)
	Set(this,"Pos.y",EdgeBottom/2)
	RemoveTrees(this,10000)
	Interface.RemoveComponent(this,"toggleRemoveAllTrees")
end

function RemoveTrees(from,dist,Remove)
	for j = 0, #TreeTypes do
		for thatTree in next, Find(from,TreeTypes[j],dist) do
			local cell = World.GetCell(thatTree.Pos.x,thatTree.Pos.y)
			if cell.Mat == "Water" or cell.Mat == "WaterShallow" or Remove == true then
				thatTree.Delete()
			end
		end
	end
end

function RemoveRoadGates()
	Set(this,"Pos.x",EdgeRight/2)
	Set(this,"Pos.y",EdgeBottom/2)
	for thatGate in next, Find(this,"RoadGate",10000) do
		thatGate.Delete()
	end
	for thatBarrier in next, Find(this,"RoadBarrier",10000) do
		thatBarrier.Delete()
	end
end

function toggleCheatsClicked()
	if World.CheatsEnabled == true then
		World.ImmediateMaterials = false
		World.ImmediateTerrain = false
		World.CheatsEnabled = false
		this.SetInterfaceCaption("toggleCheats", "tooltip_Button_ToggleCheatsOff")
	else
		World.CheatsEnabled = true
		World.ImmediateMaterials = true
		World.ImmediateTerrain = true
		this.SetInterfaceCaption("toggleCheats", "tooltip_Button_ToggleCheatsOn")
	end
end
