
local timeTot = 0
local timeLog = 0
local timePerLog = 60+math.random() / World.TimeWarpFactor
-- local Christmas = false

local Get = Object.GetProperty
local Set = Object.SetProperty
local Find = Object.GetNearbyObjects

local LightPos = { [1] = -0.005, [2] = -0.0025, [3] = 0.0025, [4] = 0.005 }

local MyStuff = { "OutdoorStoveFire","SmokeGenerator","LightRed","WallLight","Light","FireplaceLogRack","Log"
				,"ChristmasLightsSmall","ChristmasSock1","ChristmasSock2","ChristmasSock3","ChristmasSock4",
				"ChristmasSock5","ChristmasSock1L","ChristmasSock2L","ChristmasSock3L","ChristmasSock4L","ChristmasSock5L"
				}

function Create()
	DetectGameVersion()
	Set(this,"Light",true)
	LightOn = true
	Interface.AddComponent(this,"toggleDelete", "Button", "tooltip_toggleRemoveStove")
	Interface.AddComponent(this,"toggleFoundationType", "Button", "tooltip_toggleFoundation")
	Interface.AddComponent(this,"toggleIndoor", "Button", "tooltip_toggleFoundationInOut")
	Interface.AddComponent(this,"toggleLight", "Button", "tooltip_toggleStoveLightOn")
	if RedLightPossible == true then
		Interface.AddComponent(this,"toggleLightColour", "Button", "tooltip_toggleStoveLightColour")
	end
	timePerUpdate = 1
end

function DetectGameVersion()
	MyRedLight = Object.Spawn("LightRed",0,0)
	if Exists(MyRedLight) then 
		RedLightPossible = true
		MyRedLight.Delete()
	end
	-- MyWallLight = Object.Spawn("WallLight",0,0)
	MyWallLight = Object.Spawn("FloodLight",0,0)
	if Exists(MyWallLight) then
		MyWallLight.Delete()
	else
		Is2018Edition = true
	end
end

function Update(timePassed)
	if timePerUpdate == nil then
		DetectGameVersion()
		Interface.AddComponent(this,"toggleDelete", "Button", "tooltip_toggleRemoveStove")
		Interface.AddComponent(this,"toggleFoundationType", "Button", "tooltip_toggleFoundation")
		Interface.AddComponent(this,"toggleIndoor", "Button", "tooltip_toggleFoundationInOut")
		if not this.Light then
			Interface.AddComponent(this,"toggleLight", "Button", "tooltip_toggleStoveLightOff")
		else
			LightOn = true
			Interface.AddComponent(this,"toggleLight", "Button", "tooltip_toggleStoveLightOn")
			if RedLightPossible == true then
				Interface.AddComponent(this,"toggleLightColour", "Button", "tooltip_toggleStoveLightColour")
			end
		end
		for thatSmoke in next, Find(this,"SmokeGenerator",2) do
			MySmoke = thatSmoke
			break
		end	
		for thatFire in next, Find(this,"OutdoorStoveFire",1) do
			if thatFire.StoveID == this.Id.u then MyFire = thatFire end
			break
		end
		if not Is2018Edition then
			for thatLight in next, Find(this,"WallLight",1) do
				if thatLight.StoveID == this.Id.u then MyLight = thatLight end
				break
			end
			for thatLight in next, Find(this,"LightRed",1) do
				if thatLight.StoveID == this.Id.u then MyLight = thatLight end
				break
			end
		else
			for thatLight in next, Find(this,"Light",1) do
				if thatLight.StoveID == this.Id.u then MyLight = thatLight end
				break
			end
		end
		timePerUpdate = math.random(15,35) / 100
	end

	timeTot = timeTot + timePassed
	if timeTot >= timePerUpdate then
		timeTot = 0
		if this.SubType > 0 then
			this.SubType = math.random(1,4)
			if Exists(MyFire) then
				MyFire.SubType = this.SubType
				MyFire.Pos.x = this.Pos.x + LightPos[this.SubType]
			else
				timeLog = timePerLog
			end
			if LightOn and Exists(MyLight) then
				MyLight.Pos.x = this.Pos.x+0.0225 + LightPos[this.SubType]
			end
			timePerUpdate = math.random(15,35) / 100
		end
		timeLog = timeLog + timePassed
		if not Exists(MySmoke) or timeLog >= timePerLog then
			if not SmokeRemoved then
				for j = 1, 5 do
					for thatStuff in next, Find(this,MyStuff[j],2) do
						if thatStuff.StoveID == this.Id.u then thatStuff.Delete() end
					end
				end
				MyFire,MyLight,MySmoke = nil,nil,nil
				SmokeRemoved = true
			end
			this.CreateJob("LogInStove")
			this.SubType = 0
		end
	end
end

function JobComplete_LogInStove()
	this.CancelJob("LogInStove")
	MySmoke = Object.Spawn("SmokeGenerator",this.Pos.x,this.Pos.y-1.25)
	MySmoke.StoveID = this.Id.u
	MyFire = Object.Spawn("OutdoorStoveFire",this.Pos.x,this.Pos.y+0.25)
	MyFire.StoveID = this.Id.u
	if LightOn then
		if not Is2018Edition then
			if this.RedLight == true then
				MyLight = Object.Spawn("LightRed",this.Pos.x,this.Pos.y+0.05)
			else
				MyLight = Object.Spawn("WallLight",this.Pos.x,this.Pos.y-0.35)
			end
		else
			MyLight = Object.Spawn("Light",this.Pos.x,this.Pos.y+0.225)
		end
		MyLight.StoveID = this.Id.u
	end
	this.SubType = 1
	this.Damage = 0
	timeLog = 0
	SmokeRemoved = nil
	timePerLog = 60+math.random(10,60) / World.TimeWarpFactor
end

function Exists(theObject)
	if theObject ~= nil and theObject.SubType ~= nil then
		return true
	else
		return false
	end
end

function toggleLightClicked()
	if this.Light == true then
		Set(this,"Light",nil)
		LightOn = nil
		if not Is2018Edition then
			for thatLight in next, Find(this,"WallLight",1) do
				if thatLight.StoveID == this.Id.u then thatLight.Delete() end
				break
			end
			for thatLight in next, Find(this,"LightRed",1) do
				if thatLight.StoveID == this.Id.u then thatLight.Delete() end
				break
			end
			Interface.RemoveComponent(this,"toggleLightColour")
		else
			for thatLight in next, Find(this,"Light",1) do
				if thatLight.StoveID == this.Id.u then thatLight.Delete() end
				break
			end
		end
		this.SetInterfaceCaption("toggleLight", "tooltip_toggleStoveLightOff")
	else
		LightOn = true
		Set(this,"Light",true)
		if this.SubType > 0 then
			if not Is2018Edition then
				if this.RedLight == true then
					MyLight = Object.Spawn("LightRed",this.Pos.x,this.Pos.y+0.05)
				else
					MyLight = Object.Spawn("WallLight",this.Pos.x,this.Pos.y-0.35)
				end
			else
				MyLight = Object.Spawn("Light",this.Pos.x,this.Pos.y+0.225)
			end
			MyLight.StoveID = this.Id.u
		end
		this.SetInterfaceCaption("toggleLight", "tooltip_toggleStoveLightOn")
		if not Is2018Edition then
			if this.RedLight == true then
				Interface.AddComponent(this,"toggleLightColour", "Button", "tooltip_toggleStoveLightRed")
			else
				Interface.AddComponent(this,"toggleLightColour", "Button", "tooltip_toggleStoveLightWhite")
			end
		end
	end
end

function toggleLightColourClicked()
	for thatLight in next, Find(this,"WallLight",1) do
		if thatLight.StoveID == this.Id.u then thatLight.Delete() end
		break
	end
	for thatLight in next, Find(this,"LightRed",1) do
		if thatLight.StoveID == this.Id.u then thatLight.Delete() end
		break
	end
	if this.RedLight == true then
		Set(this,"RedLight",nil)
		if this.SubType > 0 then
			MyLight = Object.Spawn("WallLight",this.Pos.x,this.Pos.y-0.35)
			MyLight.StoveID = this.Id.u
		end
		this.SetInterfaceCaption("toggleLightColour", "tooltip_toggleStoveLightWhite")
	else
		Set(this,"RedLight",true)
		if this.SubType > 0 then
			MyLight = Object.Spawn("LightRed",this.Pos.x,this.Pos.y+0.05)
			MyLight.StoveID = this.Id.u
		end
		this.SetInterfaceCaption("toggleLightColour", "tooltip_toggleStoveLightRed")
	end
end

function toggleIndoorClicked()
	if this.Ind == true then
		Set(this,"Ind",false)
		this.SetInterfaceCaption("toggleIndoor", "tooltip_toggleFoundationOutdoor")
	else
		Set(this,"Ind",true)
		this.SetInterfaceCaption("toggleIndoor", "tooltip_toggleFoundationIndoor")
	end
	ChangeFoundation()
end

function toggleFoundationTypeClicked()
	for j = 1, #MyStuff do
		for thatStuff in next, Find(this,MyStuff[j],2) do
			if thatStuff.StoveID == this.Id.u then thatStuff.Delete() end
		end
	end

	if this.FoundationType == "Stone" then
		Set(this,"FoundationType","Iron")
	else
		Set(this,"FoundationType","Stone")
	end
	ChangeFoundation()
	Set(this,"HasFoundation",true)
	local X = 0
	if this.FoundationType == "Stone" then
		X = 0.25
	end
	-- if Christmas == true then
		-- if this.FoundationType == "Stone" then
			-- MyChristmasLight = Object.Spawn("ChristmasLightsSmall",this.Pos.x-0.75,this.Pos.y-0.5)
			-- MyChristmasLight.StoveID = this.Id.u
			-- MyChristmasLight.Or.y = -1
			-- MyChristmasLight = Object.Spawn("ChristmasLightsSmall",this.Pos.x+0.75,this.Pos.y-0.5)
			-- MyChristmasLight.StoveID = this.Id.u
			-- MyChristmasLight.Or.y = -1
			-- SocksRight = Object.Spawn("ChristmasSock"..math.random(1,5),this.Pos.x+1,this.Pos.y-0.85)
			-- Set(SocksRight,"StoveID",this.Id.u)
			-- SocksLeft = Object.Spawn("ChristmasSock"..math.random(1,5).."L",this.Pos.x-1,this.Pos.y-0.85)
			-- Set(SocksLeft,"StoveID",this.Id.u)
		-- else
			-- SocksRight = Object.Spawn("ChristmasSock"..math.random(1,5),this.Pos.x+1.5,this.Pos.y+0.5)
			-- Set(SocksRight,"StoveID",this.Id.u)
			-- SocksLeft = Object.Spawn("ChristmasSock"..math.random(1,5).."L",this.Pos.x-1.5,this.Pos.y+0.5)
			-- Set(SocksLeft,"StoveID",this.Id.u)
		-- end
	-- end
	MyRackLeft = Object.Spawn("FireplaceLogRack",this.Pos.x-0.65-X,this.Pos.y+0.3)
	Set(MyRackLeft,"StoveID",this.Id.u)
	MyRackRight = Object.Spawn("FireplaceLogRack",this.Pos.x+0.65+X,this.Pos.y+0.3)
	Set(MyRackRight,"StoveID",this.Id.u)
	MyLogLeft = Object.Spawn("Log",this.Pos.x-0.75-X,this.Pos.y+0.3)
	Set(MyLogLeft,"StoveID",this.Id.u)
	MyLogRight = Object.Spawn("Log",this.Pos.x+0.75+X,this.Pos.y+0.3)
	Set(MyLogRight,"StoveID",this.Id.u)
	this.SetInterfaceCaption("toggleFoundationType", "tooltip_toggleFoundation"..this.FoundationType)
end

function ChangeFoundation(Delete)

	local CompactFloor = {}
	local Tiles = {}
	
	if Delete == true then
		CompactFloor = {
			{ 4, 4, 4, 4 },
			{ 4, 4, 4, 4 },
			{ 4, 4, 4, 4 }
			}
	else
		CompactFloor = {
			{ 1, 1, 1, 1 },
			{ 1, 2, 2, 1 },
			{ 3, 3, 3, 3 }
			}
	end

	if this.FoundationType == "Stone" then
		Tiles = {
			[0] = "Excluded", -- 0 = excluded from changing
			[1] = "TiledBushFence",
			[2] = "Stone",
			[3] = "Stone",
			[4] = "Dirt"
			}
	elseif this.FoundationType == "Iron" then
		Tiles = {
			[0] = "Excluded", -- 0 = excluded from changing
			[1] = "BrickWall",
			[2] = "MosaicFloor",
			[3] = "ConcreteTiles",
			[4] = "Dirt"
			}
	else
		Tiles = {
			[0] = "Excluded", -- 0 = excluded from changing
			[1] = "BurntWall",
			[2] = "Gravel",
			[3] = "StoneTiles",
			[4] = "Dirt"
			}
	end
	
	local MyFloor = {}
	MyFloor = CompactFloor
	local x = math.floor(this.Pos.x)-3
	local y = math.floor(this.Pos.y)-2
	
	for X = 1,4 do
		for Y = 1,3 do
			local cell = World.GetCell(x+X,y+Y)
			if Tiles[MyFloor[Y][X]] ~= "Excluded" then
				cell.Mat = Tiles[MyFloor[Y][X]]
				if cell.Mat == "Dirt" then
					cell.Ind = false
				else
					cell.Ind = this.Ind
				end
			end
		end
	end
end

function toggleDeleteClicked()
	if this.HasFoundation == true then
		ChangeFoundation(true)
	end
	for j = 1, #MyStuff do
		for thatStuff in next, Find(this,MyStuff[j],2) do
			if thatStuff.StoveID == this.Id.u then thatStuff.Delete() end
		end
	end
	this.Delete()
end
