
local Get = Object.GetProperty
local Set = Object.SetProperty
local Find = Object.GetNearbyObjects

local TeamChar = { [0] = "None", [1] = "A", [2] = "B", [3] = "C", [4] = "D", [5] = "E", [6] = "F", [7] = "G", [8] = "H", [9] = "I", [10] = "J", [11] = "K", [12] = "L", [13] = "M", [14] = "N", [15] = "O", [16] = "P", [17] = "Q", [18] = "R", [19] = "S", [20] = "T", [21] = "U", [22] = "V", [23] = "W", [24] = "X", [25] = "Y", [26] = "Z" }

local timeTot = 0
local TotalTanks = 0
local CurrentTank = 0
local Range = 75
local FireAlarm = "ON"
local AlarmActive = false

function Create()
	Set(this,"AlarmUID",me["id-uniqueId"])
	Set(this,"FireAlarm","ON")
	Set(this,"FindNewWaterTanks",true)
end

function Update( timePassed )
	if timePerUpdate == nil then
		FireAlarm = this.FireAlarm
		if this.FindNewWaterTanks == false then FindMyWaterTanks() end
		FindMyAlarmLight()
		Interface.AddComponent(this,"toggleDeleteAlarm", "Button", "tooltip_caption_FireAlarm2Delete")
		Interface.AddComponent(this,this.AlarmUID.."AlarmCaption", "Caption", "tooltip_caption_FireAlarm2Toggle")
		Interface.AddComponent(this,"toggleFireAlarm", "Button", "tooltip_button_FireAlarm2Toggle",FireAlarm,"F")
		timePerUpdate = 1.5 / World.TimeWarpFactor
	end
	
	timeTot = timeTot + timePassed	
	if timeTot >= timePerUpdate then
		timeTot = 0
		if this.FindNewWaterTanks == true then
			FindMyWaterTanks()
		end
	
		if CurrentTank > 0 and FireAlarm == "ON" then
			for W = CurrentTank,TotalTanks do
				if not Exists(MyWaterTanks[W].WaterTank) then
					print("WaterTank "..W.." removed")
					table.remove(MyWaterTanks[W])
					TotalTanks = TotalTanks - 1
				elseif MyWaterTanks[W].WaterTank.FireAlarm == "ON" and MyWaterTanks[W].WaterTank.FiresInRangeDetected then
					AlarmActive = true
					this.Tooltip={ "tooltip_PrisonFireAlarm2FireFound",FireAlarm,"F",TotalTanks,"T",TeamChar[W],"A" }
					MyAlarmLight.Tooltip={ "tooltip_PrisonFireAlarm2FireFound",FireAlarm,"F",TotalTanks,"T",TeamChar[W],"A" }
				end
				break
			end
			CurrentTank = CurrentTank + 1
			if CurrentTank > TotalTanks then if TotalTanks > 0 then CurrentTank = 1 else CurrentTank = 0 end end
		end
	
		if AlarmActive == true then
			if MyAlarmLight.Hidden == true then
				MyAlarmLight.Hidden = false
			else
				MyAlarmLight.Hidden = true
			end
			Object.Sound("FireAlarm","SoundAlarm")
			Object.Sound("_Failure","TimerTickHours")
			AlarmActive = false
		else
			if MyAlarmLight.Hidden == false then
				MyAlarmLight.Hidden = true
			end
			this.Tooltip={ "tooltip_PrisonFireAlarm2",FireAlarm,"F",TotalTanks,"T" }
			MyAlarmLight.Tooltip={ "tooltip_PrisonFireAlarm2",FireAlarm,"F",TotalTanks,"T" }
		end
	end
	if MyAlarmLight.Hidden == false then Set(MyAlarmLight,"Triggered",5) end	-- for when it spawned a StatusLight instead of DLC light
end

function FindMyWaterTanks()
	print("FindMyWaterTanks")
	MyWaterTanks = {}
	TotalTanks = 0
	local TanksToSort = {}
    local nearbyWaterTanks = Find(this,"WaterTank2",10000)
	if next(nearbyWaterTanks) then
	
		for unsortedTank,dist in pairs(nearbyWaterTanks) do
			TotalTanks = TotalTanks + 1
			TanksToSort[TotalTanks] = unsortedTank.Team
		end
		table.sort(TanksToSort)
		
		TotalTanks=0
		for i,n in ipairs(TanksToSort) do 
			for sortedTank,distance in pairs(nearbyWaterTanks) do
				if sortedTank.Team == TanksToSort[i] then
					TotalTanks = TotalTanks + 1
					print("Found WaterTank "..TotalTanks.." ID: "..sortedTank.Id.u.." Team: "..TeamChar[sortedTank.Team])
					MyWaterTanks[TotalTanks] = {}
					MyWaterTanks[TotalTanks].WaterTank = sortedTank
					MyWaterTanks[TotalTanks].Team = sortedTank.Team
				end
			end
		end
	end
	TanksToSort = nil
	nearbyWaterTanks = nil
	if TotalTanks > 0 then
		CurrentTank = 1
	else
		CurrentTank = 0
		print("No WaterTanks")
	end
	this.Tooltip={ "tooltip_PrisonFireAlarm2",FireAlarm,"F",TotalTanks,"T" }
	Set(this,"FindNewWaterTanks",false)
end

function FindMyAlarmLight()
	local found = false
	local nearbyLights = Find(this,"LightRed",2)
	for thatLight, distance in pairs (nearbyLights) do
		if thatLight.AlarmUID == this.AlarmUID then
			MyAlarmLight = thatLight
			found = true
		end
	end
	nearbyLights=nil
	if found == false then
		local nearbyLights = Find(this,"StatusLight",2)
		for thatLight, distance in pairs (nearbyLights) do
			if thatLight.AlarmUID == this.AlarmUID then
				MyAlarmLight = thatLight
				found = true
			end
		end
		nearbyLights=nil
		if found == false then
			SpawnAlarmLight()
		end
	end
end
function SpawnAlarmLight()
	MyAlarmLight = Object.Spawn("LightRed", this.Pos.x,this.Pos.y)
	if not Exists(MyAlarmLight) then MyAlarmLight = Object.Spawn("StatusLight", this.Pos.x,this.Pos.y) end
	Set(MyAlarmLight,"AlarmUID",this.AlarmUID)
	Set(this,"Slot0.i",MyAlarmLight.Id.i)
	Set(this,"Slot0.u",MyAlarmLight.Id.u)
	Set(MyAlarmLight,"CarrierId.i",this.Id.i)
	Set(MyAlarmLight,"CarrierId.u",this.Id.u)
	Set(MyAlarmLight,"Loaded",true)
	Set(MyAlarmLight,"Hidden",true)
end

function toggleDeleteAlarmClicked()
	if not Exists(MyAlarmLight) then FindMyAlarmLight() end
	MyAlarmLight.Delete()
	this.Delete()
end

function toggleFireAlarmClicked()
	if FireAlarm == "ON" then
		FireAlarm = "OFF"
		MyWaterTanks = nil
		CurrentTank = 0
		TotalTanks = 0
		this.Tooltip={ "tooltip_PrisonFireAlarm2",FireAlarm,"F",TotalTanks,"T" }
		MyAlarmLight.Tooltip={ "tooltip_PrisonFireAlarm2",FireAlarm,"F",TotalTanks,"T" }
	else
		FireAlarm = "ON"
		Set(this,"FindNewWaterTanks",true)
	end
	Set(this,"FireAlarm",FireAlarm)
	this.SetInterfaceCaption("toggleFireAlarm", "tooltip_button_FireAlarm2Toggle",FireAlarm,"F")
end

function Exists(theObject)
	if theObject ~= nil and theObject.SubType ~= nil then
		return true
	else
		return false
	end
end
