
local Get = Object.GetProperty
local Set = Object.SetProperty
local Find = Object.GetNearbyObjects

local timeTot = 0

local TotalTanks = 0
local TotalLockers = 0

local CurrentTank = 0
local CurrentLocker = 0

local TeamChar = { [0] = "None", [1] = "A", [2] = "B", [3] = "C", [4] = "D", [5] = "E", [6] = "F", [7] = "G", [8] = "H", [9] = "I", [10] = "J", [11] = "K", [12] = "L", [13] = "M", [14] = "N", [15] = "O", [16] = "P", [17] = "Q", [18] = "R", [19] = "S", [20] = "T", [21] = "U", [22] = "V", [23] = "W", [24] = "X", [25] = "Y", [26] = "Z" }

function Create()
	print("Create")
	Set(this,"FindNewLockers",true)
	Set(this,"FindNewWaterTanks",true)
	for thatChief in next, Find(this,"PrisonFireman2Chief",10000) do
		if thatChief.Id.u ~= this.Id.u then
			thatChief.Delete()
		end
	end
end

function Update(timePassed)
	if timePerUpdate == nil then
		if this.FindNewWaterTanks == false then LoadMyWaterTanks() end
		if this.FindNewLockers == false then LoadMyLockers() end		
		timePerUpdate = 1
		Interface.AddComponent(this,"FindNewLockers", "Button", "tooltip_button_ChiefPopulate")
	end
	
	timeTot = timeTot + timePassed
	if timeTot >= timePerUpdate then
		if this.FindNewWaterTanks == true then 
			MyLockers = nil
			FindNewWaterTanks()
		end
		-- if this.FindNewLockers == true then FindNewLockers() end
	end
	
	if CurrentTank > 0 then
		for W = CurrentTank,TotalTanks do
			if not Exists(MyWaterTanks[W].WaterTank) then
				print("WaterTank "..W.." removed")
				ResetLockers(MyWaterTanks[W].Team)	-- empties all corresponding lockers and sacks their prison firemen
				table.remove(MyWaterTanks[W])
				TotalTanks = TotalTanks - 1
			end
			break
		end
		CurrentTank = CurrentTank + 1
		if CurrentTank > TotalTanks then if TotalTanks > 0 then CurrentTank = 1 else CurrentTank = 0 end end
	end
	
	if CurrentLocker > 0 then
		for L = CurrentLocker,TotalLockers do
			if not Exists(MyLockers[L].Locker) then
				print("Locker "..L.." removed")
				if MyLockers[L].Team > 0 then SackPrisonFireman(MyLockers[L].Team,MyLockers[L].Member) end
				table.remove(MyLockers[L])
				TotalLockers = TotalLockers - 1
			elseif MyLockers[L].Team > 0 and not Exists(MyLockers[L].PrisonFireman) then
				print("PrisonFiremanT"..TeamChar[MyLockers[L].Team].."M"..MyLockers[L].Member.." removed")
				ResetLockers(MyLockers[L].Team,MyLockers[L].Member)	-- empties corresponding locker
			elseif MyLockers[L].Team > 0 and MyLockers[L].Locker.SubType == 1 and MyLockers[L].PrisonFireman.ShowerSequenceStarted == true then
				Object.CreateJob(MyLockers[L].Locker,"ChangeFiremanClothesT"..MyLockers[L].Team.."M"..MyLockers[L].Member)
			elseif MyLockers[L].Team > 0 and MyLockers[L].Locker.SubType == 1 and MyLockers[L].PrisonFireman.PutBeneathLocker == true then
				print("PutBeneathLocker Team:"..MyLockers[L].Team.." Member: "..MyLockers[L].Member)	-- Real Fireman grabbed the hose from the watertank and starts to fight fires
				for W = 1,TotalTanks do																	-- Prison Fireman meanwhile gets stored beneath its locker
					if MyWaterTanks[W].WaterTank.Id.u == MyLockers[L].PrisonFireman.WaterTankID then
						Set(MyWaterTanks[W].WaterTank,"Slot"..(MyLockers[L].Member+3)..".i",-1)
						Set(MyWaterTanks[W].WaterTank,"Slot0"..(MyLockers[L].Member+3)..".u",-1)
						Set(MyLockers[L].PrisonFireman,"CarrierId.i",-1)
						Set(MyLockers[L].PrisonFireman,"CarrierId.u",-1)
						Set(MyLockers[L].PrisonFireman,"Loaded",false)
						MyLockers[L].PrisonFireman.Pos.x = MyLockers[L].Locker.Pos.x
						MyLockers[L].PrisonFireman.Pos.y = MyLockers[L].Locker.Pos.y
						break
					end
				end
				Set(MyLockers[L].Locker,"Slot0.i",MyLockers[L].PrisonFireman.Id.i)
				Set(MyLockers[L].Locker,"Slot0.u",MyLockers[L].PrisonFireman.Id.u)
				Set(MyLockers[L].PrisonFireman,"CarrierId.i",MyLockers[L].Locker.Id.i)
				Set(MyLockers[L].PrisonFireman,"CarrierId.u",MyLockers[L].Locker.Id.u)
				Set(MyLockers[L].PrisonFireman,"Loaded",true)
				MyLockers[L].PrisonFireman.PutBeneathLocker = nil
			elseif MyLockers[L].Team > 0 and MyLockers[L].Locker.SubType == 1 and MyLockers[L].PrisonFireman.ReviveFromLocker == true then
				print("ReviveFromLocker Team:"..MyLockers[L].Team.." Member: "..MyLockers[L].Member)
				MyLockers[L].Locker.Slot0.i = -1
				MyLockers[L].Locker.Slot0.u = -1
				MyLockers[L].PrisonFireman.CarrierId.i = -1
				MyLockers[L].PrisonFireman.CarrierId.u = -1
				MyLockers[L].PrisonFireman.Loaded = false
				MyLockers[L].PrisonFireman.SubType = 1	-- Real Fireman died during a fire, revive the Prison Fireman, let him take a shower to create a delay before this guy can be used again (punishes player a bit for letting a fireman die)
				MyLockers[L].PrisonFireman.ReviveFromLocker = nil
				MyLockers[L].PrisonFireman.ShowerSequenceStarted = true	-- He will then walk to his watertank to do a new Grab Hose job which enables the priordead Fireman again to continue fighting fires
			elseif MyLockers[L].Team > 0 and MyLockers[L].Locker.SubType == 1 and MyLockers[L].PrisonFireman.FinishedAfterFire == true then
				print("FinishedAfterFire Team:"..MyLockers[L].Team.." Member: "..MyLockers[L].Member)
				MyLockers[L].Locker.Slot0.i = -1
				MyLockers[L].Locker.Slot0.u = -1
				MyLockers[L].PrisonFireman.CarrierId.i = -1
				MyLockers[L].PrisonFireman.CarrierId.u = -1
				MyLockers[L].PrisonFireman.Loaded = false
				MyLockers[L].PrisonFireman.SubType = 1	-- Make him dirty and teleport this guy to the coresponding watertank after the real Fireman put his hose back
				for W = 1,TotalTanks do
					if MyWaterTanks[W].WaterTank.Id.u == MyLockers[L].PrisonFireman.WaterTankID then
						MyLockers[L].PrisonFireman.Pos.x = MyWaterTanks[W].WaterTank.Pos.x
						MyLockers[L].PrisonFireman.Pos.y = MyWaterTanks[W].WaterTank.Pos.y
						break
					end
				end
				MyLockers[L].PrisonFireman.Hidden = false
				MyLockers[L].PrisonFireman.FinishedAfterFire = nil
				MyLockers[L].PrisonFireman.ShowerSequenceStarted = true
			end
			break
		end
		CurrentLocker = CurrentLocker + 1
		if CurrentLocker > TotalLockers then if TotalLockers > 0 then CurrentLocker = 1 else CurrentLocker = 0 end end
	end
		
end

function LoadMyWaterTanks()
	print("LoadMyWaterTanks")
	MyWaterTanks = {}
	TotalTanks = 0
	local TanksToSort = {}
    local nearbyWaterTanks = Find(this,"WaterTank2",10000)
	if next(nearbyWaterTanks) then
	
		for unsortedTank,dist in pairs(nearbyWaterTanks) do
			TotalTanks = TotalTanks + 1
			TanksToSort[TotalTanks] = unsortedTank.Team
		end
		table.sort(TanksToSort)
		
		TotalTanks=0
		for i,n in ipairs(TanksToSort) do 
			for sortedTank,distance in pairs(nearbyWaterTanks) do
				if sortedTank.Team == TanksToSort[i] then
					TotalTanks = TotalTanks + 1
					print("Load WaterTank "..TotalTanks.." ID: "..sortedTank.Id.u.." Team: "..TeamChar[sortedTank.Team])
					MyWaterTanks[TotalTanks] = {}
					MyWaterTanks[TotalTanks].WaterTank = sortedTank
					MyWaterTanks[TotalTanks].Team = sortedTank.Team
				end
			end
		end
	end
	
	nearbyWaterTanks = nil
	if TotalTanks > 0 then
		CurrentTank = 1
		print("MyWaterTanks found: "..TotalTanks)
	else
		CurrentTank = 0
		print("No WaterTanks")
	end
end

function LoadMyLockers()
	print("LoadMyLockers")
	MyLockers = {}
	TotalLockers = 0
    local nearbyLockers = Find(this,"FiremanLocker2",10000)
	if next(nearbyLockers) then
		for thatLocker,dist in pairs(nearbyLockers) do
			TotalLockers = TotalLockers + 1
			print("Load Locker "..TotalLockers.."  ID: "..thatLocker.Id.u.." Team: "..TeamChar[thatLocker.Team].." Member: "..thatLocker.Member)
			MyLockers[TotalLockers] = {}
			MyLockers[TotalLockers].Locker = thatLocker
			MyLockers[TotalLockers].Team = thatLocker.Team
			MyLockers[TotalLockers].Member = thatLocker.Member
			if MyLockers[TotalLockers].Team > 0 then
				MyLockers[TotalLockers].Locker.Tooltip = { "tooltip_LockerInUse",thatLocker.HomeUID,"W",TeamChar[thatLocker.Team],"T",thatLocker.Member,"M" }
			else
				MyLockers[TotalLockers].Locker.Tooltip = "tooltip_LockerNotInUse"
			end
			if Get(thatLocker,"HomeUID") ~= "None" then
				for thatPF in next, Find(this,"PrisonFiremanT"..thatLocker.Team.."M"..thatLocker.Member,10000) do
					print("Load PrisonFireman ID: "..thatPF.Id.u.." Team: "..TeamChar[thatPF.Team].." Member: "..thatPF.Member)
					thatPF.Tooltip = { "tooltip_PrisonFireman2",thatPF.HomeUID,"W",TeamChar[thatPF.Team],"T",thatPF.Member,"M",thatPF.Rank,"R" }
					MyLockers[TotalLockers].PrisonFireman = thatPF
				end
			end
		end
	end
	
	nearbyLockers = nil
	if TotalLockers > 0 then
		CurrentLocker = 1
		print("MyLockers found: "..TotalLockers)
	else
		CurrentLocker = 0
		print("No FiremanLockers")
	end
end

function Exists(theObject)
	if theObject ~= nil and theObject.SubType ~= nil then
		return true
	else
		return false
	end
end

function FindAllLockers()
	print("FindAllLockers")
	MyLockers = {}
	TotalLockers = 0
	nearbyLockers = Find(this,"FiremanLocker2",10000)
	if next(nearbyLockers) then
		for thatLocker,dist in pairs(nearbyLockers) do
			TotalLockers = TotalLockers + 1
			print("Found Locker "..TotalLockers.."  ID: "..thatLocker.Id.u.." Team: "..TeamChar[thatLocker.Team].." Member: "..thatLocker.Member)
			MyLockers[TotalLockers] = {}
			MyLockers[TotalLockers].Locker = thatLocker
			MyLockers[TotalLockers].Team = thatLocker.Team
			MyLockers[TotalLockers].Member = thatLocker.Member
			if Get(thatLocker,"HomeUID") ~= "None" then
				for thatPF in next, Find(this,"PrisonFiremanT"..thatLocker.Team.."M"..thatLocker.Member,10000) do
					print("Found PrisonFireman ID: "..thatPF.Id.u.." Team: "..TeamChar[thatPF.Team].." Member: "..thatPF.Member)
					MyLockers[TotalLockers].PrisonFireman = thatPF
				end
			end
		end
	end
	
	nearbyLockers = nil
	if TotalLockers > 0 then
		CurrentLocker = 1
		print("MyLockers found: "..TotalLockers)
	else
		CurrentLocker = 0
		print("No FiremanLockers")
	end
end

function CheckForNearestFiremanLocker(theTank)
	print("CheckForNearestFiremanLocker")
	if MyLockers == nil then FindAllLockers() end
	local CurrentDist = 10000
	LockerToUse = 0
	if TotalLockers > 0 then
		for L = 1,TotalLockers do
			local thatLocker = MyLockers[L].Locker
			if Get(thatLocker,"HomeUID") == "None" then
				local dX1 = thatLocker.Pos.x
				local dX2 = theTank.Pos.x
				local dY1 = thatLocker.Pos.y
				local dY2 = theTank.Pos.y
				local TankDistance = math.sqrt((dX2-dX1)^2+(dY2-dY1)^2)
				if TankDistance < CurrentDist then
					CurrentDist = TankDistance
					LockerToUse = L
				end
			end
		end
	end
end

function FindNewWaterTanks()
	print("FindNewWaterTanks")
	MyWaterTanks = {}
	TotalTanks = 0
	local TanksToSort = {}
    local nearbyWaterTanks = Find(this,"WaterTank2",10000)
	if next(nearbyWaterTanks) then
	
		for unsortedTank,dist in pairs(nearbyWaterTanks) do
			TotalTanks = TotalTanks + 1
			TanksToSort[TotalTanks] = unsortedTank.Team
		end
		table.sort(TanksToSort)
		
		TotalTanks=0
		for i,n in ipairs(TanksToSort) do 
			for sortedTank,distance in pairs(nearbyWaterTanks) do
				if sortedTank.Team == TanksToSort[i] then
					TotalTanks = TotalTanks + 1
					print("Found WaterTank "..TotalTanks.." ID: "..sortedTank.Id.u.." Team: "..TeamChar[sortedTank.Team])
					MyWaterTanks[TotalTanks] = {}
					MyWaterTanks[TotalTanks].WaterTank = sortedTank
					MyWaterTanks[TotalTanks].Team = sortedTank.Team
				end
			end
		end
	end
	TanksToSort = nil
	nearbyWaterTanks = nil
	if TotalTanks > 0 then
		CurrentTank = 1
		for W = 1,TotalTanks do
			local thatTank = MyWaterTanks[W].WaterTank
			for PF = 1,4 do
				if (Get(thatTank,"TimeWarp") ~= nil and Get(thatTank,"HomeUID") ~= nil and Get(thatTank,"Member"..PF.."ID") == "None" and Get(thatTank,"WaterTankBusy") == false)
				or (Get(thatTank,"TimeWarp") ~= nil and Get(thatTank,"Member"..PF.."ID") == "None" and Get(thatTank,"Fireman"..PF.."Available") == true and Get(thatTank,"WaterTankBusy") == true) then
					
					CheckForNearestFiremanLocker(thatTank)
					if LockerToUse == 0 then
						print("No free locker found")
						break
					else
						NewLocker = MyLockers[LockerToUse].Locker
						
						newPF = Object.Spawn("PrisonFiremanT"..thatTank.Team.."M"..PF,NewLocker.Pos.x+NewLocker.Or.x,NewLocker.Pos.y+NewLocker.Or.y)
						print("Spawn PrisonFireman ID: "..newPF.Id.u.." Team: "..TeamChar[thatTank.Team].." Member: "..PF)
						Set(thatTank,"Member"..PF.."ID",newPF.Id.u)
						
						Set(newPF,"SubType",1)
						Set(newPF,"FiremanLockerID",NewLocker.Id.u)
					
						Set(NewLocker,"SubType",1)
						Set(NewLocker,"HomeUID",thatTank.HomeUID)
						Set(NewLocker,"WaterTankID",thatTank.Id.u)
						Set(NewLocker,"Team",thatTank.Team)
						Set(NewLocker,"Member",PF)
						NewLocker.Tooltip = { "tooltip_LockerInUse",NewLocker.HomeUID,"W",TeamChar[NewLocker.Team],"T",PF,"M" }
												
						Set(newPF,"HomeUID",thatTank.HomeUID)
						Set(newPF,"WaterTankID",thatTank.Id.u)
						Set(newPF,"Team",thatTank.Team)
						Set(newPF,"Member",PF)
						if PF == 4 then
							Set(newPF,"Rank","Crew Manager")
						else
							Set(newPF,"Rank","Firefighter")
						end
						newPF.Tooltip = { "tooltip_PrisonFireman2",thatTank.HomeUID,"W",TeamChar[newPF.Team],"T",PF,"M",newPF.Rank,"R" }
						Set(newPF,"ShowerSequenceStarted",true)
						Object.CreateJob(NewLocker,"ChangeFiremanClothesT"..NewLocker.Team.."M"..NewLocker.Member)
						Set(thatTank,"CheckForNewMembers",true)
						Set(thatTank,"Initialised",true)
						MyLockers[LockerToUse].Team = NewLocker.Team
						MyLockers[LockerToUse].Member = NewLocker.Member
						MyLockers[LockerToUse].PrisonFireman = newPF
					end
				end
			end
		end
	else
		CurrentTank = 0
		print("No WaterTanks")
	end
	Set(this,"FindNewWaterTanks",false)
	Set(this,"FindNewLockers",false)
	UpdatePrisonFireAlarms()
end

function FindNewLockersClicked()
	FindNewLockers()
end

function FindNewLockers()
	print("FindNewLockers")
	local Populate = false
	for W = 1,TotalTanks do
		if MyWaterTanks[W].WaterTank.TeamMembers < 4 then
			Populate = true
			break
		end
	end
	if Populate == true then
		MyLockers = nil
		FindNewWaterTanks()
	end
	Set(this,"FindNewLockers",false)
end

function SackPrisonFireman(theTeam,theMember)
	print("SackPrisonFiremanT"..TeamChar[theTeam].."M"..theMember)
	for thatPF in next, Find(this,"PrisonFiremanT"..theTeam.."M"..theMember,10000) do
		thatPF.Delete()
	end
	for W = 1,TotalTanks do
		if MyWaterTanks[W].WaterTank.Team == theTeam then
			Set(MyWaterTanks[W].WaterTank,"Fireman"..theMember.."ID","None")
			Set(MyWaterTanks[W].WaterTank,"TeamMembers",MyWaterTanks[W].WaterTank.TeamMembers-1)
			break
		end
	end
end

function ResetLockers(theTeam,theMember)
	if theMember == nil then
		for L = 1,TotalLockers do
			if MyLockers[L].Team == theTeam then	-- empty all lockers & sack prison firemen which belonged to the removed WaterTank
				print("ResetLockers from team "..TeamChar[theTeam])
				Object.CancelJob(MyLockers[L].Locker,"ChangeFiremanClothesT"..theTeam.."M"..MyLockers[L].Member)
				SackPrisonFireman(MyLockers[L].Team,MyLockers[L].Member)
				MyLockers[L].Locker.SubType = 0
				MyLockers[L].Locker.HomeUID = "None"
				MyLockers[L].Locker.WaterTankID = "None"
				MyLockers[L].Locker.Team = 0
				MyLockers[L].Locker.Member = 0
				MyLockers[L].Team = 0
				MyLockers[L].Member = 0
				MyLockers[L].Locker.Tooltip = "tooltip_LockerNotInUse"
			end
		end
	else
		for L = 1,TotalLockers do
			if MyLockers[L].Team == theTeam and MyLockers[L].Member == theMember then	-- empty the locker of a sacked prison fireman
				print("ResetLocker from sacked PrisonFiremanT"..TeamChar[theTeam].."M"..theMember)
				Object.CancelJob(MyLockers[L].Locker,"ChangeFiremanClothesT"..theTeam.."M"..theMember)
				MyLockers[L].Locker.SubType = 0
				MyLockers[L].Locker.HomeUID = "None"
				MyLockers[L].Locker.WaterTankID = "None"
				MyLockers[L].Locker.Team = 0
				MyLockers[L].Locker.Member = 0
				MyLockers[L].Team = 0
				MyLockers[L].Member = 0
				MyLockers[L].Locker.Tooltip = "tooltip_LockerNotInUse"
				break
			end
		end
		for W = 1,TotalTanks do
			if MyWaterTanks[W].WaterTank.Team == theTeam then	-- update the watertank of the sacked prison fireman
				Set(MyWaterTanks[W].WaterTank,"Fireman"..theMember.."ID","None")
				Set(MyWaterTanks[W].WaterTank,"TeamMembers",MyWaterTanks[W].WaterTank.TeamMembers-1)
				break
			end
		end
	end
end

function UpdatePrisonFireAlarms()
	for thatAlarm in next, Find(this,"PrisonFireAlarm2",10000) do
		Set(thatAlarm,"FindNewWaterTanks",true)
	end
end
